
--[[
	------------------------------------------------
	| YLVF 0.8.9+ | 2022-07-16 (yyyy-mm-dd) | V1.8 |
	------------------------------------------------
]]

#include "../YLVFdata.lua"

VERSION = "1.8"

function init()
	ready = false
	latestVersion = ""
	showNotice = false
	fade = 1
	
	panelTranslate = 0
	selectVehicle = true
	choosenVehicle = 0
	prevChoosen = 0
	inSection = false
	selectSection = 1
	lastClick = 0
	
	selectionList = {1, 1, 0, 1, {}}
	previousList = {0, 0, 0, 0, {}, {}}
	compChecklist = {}
	colorList = {}
	changeColor = 1
	savedColor = {}
	presetColor = 0
	previewList = {}
	previewTrans = {}
	canSpawn = false
	
	changeR = false
	changeG = false
	changeB = false
	changeRstr = ""
	changeGstr = ""
	changeBstr = ""
	
	saveVehicle = false
	showList = false
	editVehicle = false
	emptySlot = {}
	savedList = {}
	selectSaved = 0
	canLoad = false
	showDelete = false
	showEdit = false
	blurVal = 0
	blurVal2 = 0
	blurVal3 = 0
	
	newName = ""
	editName = false
	newDesc = ""
	editDesc = false
	shortCodeStr = ""
	
	newNameChange = ""
	chnageName = false
	newDescChange = ""
	changeDesc = false
	overwrite = false
	
	freeCam = false
	close = false
	
	slideValue = 0
	slidePos = 0
	colorTrans = 0
	colorPos = 0
	moveSpeed = 20
	
	slotNum = 0
	
	lastTime = 0

	colorDone = false
	autoPre = false
	advPre = false

	local keys = ListKeys("YLVF.packs")
	if #keys < GetInt("YLVF.pack.totalnum") then
		packIndex = #keys+1
		SetString("YLVF.packs."..packIndex..".name", PACKNAME)
		SetBool("YLVF.packs."..packIndex..".active", false)
		unique = true
		ready = true
	end

	slotNum = #ListKeys("YLVF.colors.slot")
	for i=1, slotNum do
		savedColor[i] = GetString("YLVF.colors.slot."..i)
	end

	local indexOffset = 0
	local savedNum = #ListKeys("savegame.mod.vehicles")
	if savedNum > 0 then
		for i=1, savedNum do
			local index = i + indexOffset
			if HasKey("savegame.mod.vehicles."..index) then
				local vehicleName = GetString("savegame.mod.vehicles."..index..".name")
				local vehicleDesc = GetString("savegame.mod.vehicles."..index..".desc")
				local vehicleModel = GetInt("savegame.mod.vehicles."..index..".model")
				table.insert(savedList, {name = vehicleName, desc = vehicleDesc, model = vehicleModel, listPos = index})
			else
				repeat
					emptySlot[#emptySlot+1] = index
					indexOffset = indexOffset + 1
					index = i + indexOffset
				until (HasKey("savegame.mod.vehicles."..index) or indexOffset > 1000)
				local vehicleName = GetString("savegame.mod.vehicles."..index..".name")
				local vehicleDesc = GetString("savegame.mod.vehicles."..index..".desc")
				local vehicleModel = GetInt("savegame.mod.vehicles."..index..".model")
				table.insert(savedList, {name = vehicleName, desc = vehicleDesc, model = vehicleModel, listPos = index})
			end
		end
	end

	latestVersion = GetString("YLVF.toolkit.version", VERSION)
end

function tick(dt)
	if ready then
		if InputPressed("any") and freeCam then
			freeCam = false
			SetBool("YLVF.pack.freecam", false)
			local lastKey = InputLastPressedKey()
			if lastKey == "esc" then
				SetPlayerVehicle(0)

				for l=#previewList, 1, -1 do
					if IsHandleValid(previewList[l]) then
						Delete(previewList[l])
					end
				end
			elseif lastKey == "return" or lastKey == "space" then
				SetBool("YLVF.packs."..packIndex..".active", false)
				SetBool("YLVF.pack.sub", false)
				previewList = {}
				previewTrans = {}
			else
				if GetPlayerVehicle() ~= previewList[1] then
					SetPlayerVehicle(previewList[1])
				end
			end
		end
	end
end

function draw(dt)
	if unique then
		
		if GetBool("YLVF.packs."..packIndex..".active") and panelTranslate == 0 then

			SetValue("panelTranslate", 500, "cosine", 0.1)
			slotNum = #ListKeys("YLVF.colors.slot")
			for i=1, slotNum do
				savedColor[i] = GetString("YLVF.colors.slot."..i)
			end
			close = true

		elseif not GetBool("YLVF.packs."..packIndex..".active") and panelTranslate == 500 then

			SetValue("panelTranslate", 0, "cosine", 0.1)
			close = false

			if previewList ~= {} and previewList[1] ~= nil then
				SetPlayerVehicle(0)
				for l=#previewList, 1, -1 do
					if IsHandleValid(previewList[l]) then
						Delete(previewList[l])
					end
				end
				previewList = {}
				previewTrans = {}
			end
		end

		if panelTranslate > 0 then
			SetBool("game.disablepause", true)
			autoPre = GetBool("YLVF.options.autopre")
			advPre = GetBool("YLVF.options.advpre")
			shortCode = GetBool("YLVF.options.shortCode")

			if InputPressed("pause") and not showDelete then

				SetBool("YLVF.packs."..packIndex..".active", false)
				SetBool("YLVF.pack.sub", false)

				if previewList ~= {} and previewList[1] ~= nil then
					SetPlayerVehicle(0)
					for l=#previewList, 1, -1 do
						if IsHandleValid(previewList[l]) then
							Delete(previewList[l])
						end
					end
					previewList = {}
					previewTrans = {}
				end
			end

			if InputPressed(GetString("YLVF.pack.key")) then
				SetBool("YLVF.packs."..packIndex..".active", false)
				SetBool("YLVF.pack.sub", false)
				SetBool("YLVF.pack.menu", true)
			end

			if showDelete and blurVal == 0 then
				SetValue("blurVal", 0.5, "cosine", 0.1)
			end

			if not showDelete and blurVal == 0.5 then
				SetValue("blurVal", 0, "cosine", 0.1)
			end

			if saveVehicle and blurVal2 == 0 then
				SetValue("blurVal2", 0.25, "cosine", 0.1)
			end

			if not saveVehicle and blurVal2 == 0.25 then
				SetValue("blurVal2", 0, "cosine", 0.1)
			end

			if editVehicle and blurVal3 == 0 then
				SetValue("blurVal3", 0.25, "cosine", 0.1)
			end

			if not editVehicle and blurVal3 == 0.25 then
				SetValue("blurVal3", 0, "cosine", 0.1)
			end

			canSpawn = selectionList[1] > 0 and selectionList[2] > 0 and selectionList[4] > 0

			UiPush()
				if not freeCam then
					if close then
						UiMakeInteractive()
					end
					SetBool("YLVF.pack.freecam", false)
				else
					SetBool("YLVF.pack.freecam", true)
					UiPush()
						UiAlign("middle center")
						UiTranslate(UiCenter(), 47)
						UiColorFilter(1, 1, 1, 0.95)
						UiColor(0, 0, 0, 0.55)
						UiImageBox("ui/common/box-solid-4.png", 480, 54, 15, 15)
						UiFont("bold.ttf", 30)
						UiColor(1, 0.2, 0.2)
						UiText("Press Any Key to Exit Free Camera")
					UiPop()
					UiPush()
						UiAlign("middle center")
						UiTranslate(UiCenter(), UiHeight()-90)
						UiColorFilter(1, 1, 1, 0.95)
						UiColor(0.2, 0.2, 0.2, 0.55)
						UiImageBox("ui/common/box-solid-4.png", 480, 50, 15, 15)
						UiFont("bold.ttf", 26)
						UiColor(1, 1, 1)
						UiText("\"Space\" or \"Enter\" -> Confirm and Drive")
					UiPop()
				end
				UiAlign("top left")
				UiTranslate(panelTranslate-480, 20)
				UiColorFilter(1, 1, 1, 0.95)
				UiColor(0, 0, 0, 0.55)
				UiImageBox("ui/common/box-solid-4.png", 480, 1040, 15, 15)
				UiAlign("top center")
				UiTranslate(240, 30)
				UiPush() -- title
					UiColor(1, 1, 1)

					UiFont("bold.ttf", 40)
					wid, hig = UiGetTextSize(PACKNAME)
					if wid > 400 then
						UiPush()
							UiWordWrap(400)
							widWrap, higWrap = UiGetTextSize(PACKNAME)
						UiPop()
					end
					UiPush()
						UiFont("regular.ttf", 18)
						widau, higau = UiGetTextSize(PACKAUTHOR)
					UiPop()

					if wid+widau > 462 then
						if wid > 400 then
							UiTranslate(-math.min(widau, 50)/2-6, -14)
							UiWordWrap(400)
							UiText(PACKNAME)
							UiAlign("bottom left")
							UiTranslate(widWrap/2, higWrap)
							if widau > 50 then
								UiTranslate(48-widau, 0)
							end
							UiColor(0.9, 0.9, 0.9)
							UiFont("regular.ttf", 18)
							UiText("by "..PACKAUTHOR)
						else
							UiText(PACKNAME)
							UiAlign("bottom left")
							UiTranslate(wid/2-widau-22, hig+higau+4)
							UiColor(0.9, 0.9, 0.9)
							UiFont("regular.ttf", 18)
							UiText("by "..PACKAUTHOR)
						end
					else
						UiTranslate(-widau/2-4, 0)
						UiText(PACKNAME)
						UiAlign("bottom left")
						UiTranslate(wid/2+4, hig+12)
						UiColor(0.9, 0.9, 0.9)
						UiFont("regular.ttf", 18)
						UiText("by "..PACKAUTHOR)
					end
				UiPop()
				UiTranslate(0, 70)
				UiPush()
					UiColor(0.75, 0.75, 0.75)
					UiRect(470, 3)
				UiPop()
				UiTranslate(0, 15)
				UiPush() -- selections
					UiTranslate(-150, 0)
					UiAlign("top left")
					UiWindow(380, 850, true)
					UiAlign("top left")
					UiColor(0, 0, 0, 0.1)
					UiRect(UiWidth(), UiHeight())

					if inSection and choosenVehicle ~= 0 then
						local group = vehicles[choosenVehicle][3][selectSection]

						if #group > 8 then
							buttonWid = 344
							local length = (#group+1)*105
							local windowH = UiHeight()

							if UiIsMouseInRect(UiWidth(), UiHeight()) and not InputDown("lmb") then
								slidePos = slidePos - InputValue("mousewheel")*25
							end

							slidePos = math.min(length-windowH, math.max(0, slidePos))
							if not clicked then
								SetValue("slideValue", slidePos, "cosine", 0.05)
							end

							UiPush()
								UiTranslate(UiWidth(), 0)
								UiAlign("top right")
								UiColor(0.2, 0.2, 0.2, 0.4)
								UiImageBox("ui/common/box-solid-6.png", 20, UiHeight(), 4, 4)
								UiTranslate(-2, 2+slideValue*windowH/length)

								local slideBarL = windowH*windowH/length-4

								if (UiIsMouseInRect(16, slideBarL) or clicked) and InputDown("lmb") then
									slideValue = slideValue + InputValue("mousedy")*length/windowH
									slideValue = math.min(length-windowH, math.max(0, slideValue))
									slidePos = slideValue
									clicked = true
									UiColor(0.5, 0.5, 0.5)
								else
									clicked = false
									if UiIsMouseInRect(16, slideBarL) then
										UiColor(0.8, 0.8, 0.8)
									else
										UiColor(0.7, 0.7, 0.7)
									end
								end
								UiImageBox("ui/common/box-solid-6.png", 16, slideBarL, 4, 4)
							UiPop()
							UiTranslate(0, -slideValue)
						else
							buttonWid = 364
						end

						if #group == 0 then
							UiTranslate(190, 300)
							UiAlign("middle center")
							UiFont("bold.ttf", 40)
							UiColor(1, 0.6, 0, 0.5)
							UiText("No Available Parts")
							if selectSection == 5 then
								selectionList[selectSection] = {}
							else
								selectionList[selectSection] = 0
							end
						else
							UiTranslate(8, 8)
							UiButtonPressDist(0)
							UiButtonPressColor(0.3, 0.7, 0.3)
							for i=1, #group do
								local canSelect = true
								local blackListMain = group[i].blackList

								if blackListMain then
									local needReverseCheck = false
									local reverseCheck = false

									canSelect, needReverseCheck, reverseCheck = CheckSub(blackListMain.p1, 1, canSelect, needReverseCheck, reverseCheck)
									canSelect, needReverseCheck, reverseCheck = CheckSub(blackListMain.p2, 2, canSelect, needReverseCheck, reverseCheck)
									canSelect, needReverseCheck, reverseCheck = CheckSub(blackListMain.p3, 3, canSelect, needReverseCheck, reverseCheck)
									canSelect, needReverseCheck, reverseCheck = CheckSub(blackListMain.p4, 4, canSelect, needReverseCheck, reverseCheck)
									canSelect, needReverseCheck, reverseCheck = CheckSub(blackListMain.p5, 5, canSelect, needReverseCheck, reverseCheck)

									if canSelect and needReverseCheck then
										canSelect = reverseCheck
									end
								end
								UiPush()
									if canSelect then
										if selectSection == 5 and lastClick == i then
											UiButtonImageBox("ui/common/score-frame-7.png", 21, 21, 0.45, 1, 0.15)
										else
											UiButtonImageBox("ui/common/score-frame-7.png", 21, 21, 0.85, 0.85, 0.85)
										end
									else
										UiButtonImageBox("ui/common/score-frame-7.png", 21, 21, 1, 0.55, 0)
									end
									UiButtonHoverColor(0.4, 1, 0.4)
									UiColor(1, 1, 1)
									UiPush()
										UiTranslate(7, 7)
										UiPush()
											UiFont("regular.ttf", 28)
											local compName = group[i].name or "unnamed"
											if string.len(compName) > 33 then
												compName = string.sub(compName, 1, 33)
											end
											if compName == "" then compName = "unnamed" end
											UiText(compName)
										UiPop()
										UiTranslate(0, 36)
										UiPush()
											UiFont("regular.ttf", 22)
											local compDesc = group[i].desc or ""
											UiWordWrap(300)
											UiText(compDesc)
										UiPop()
										if canSelect then
											if selectSection ~= 5 then
												if selectionList[selectSection] == i then
													UiTranslate(buttonWid-54, 15)
													UiScale(1.5)
													UiColor(0, 1, 0)
													UiImage("ui/hud/checkmark.png")
												end
											else
												local content = selectionList[selectSection]
												for c=1, #content do
													if content[c][1] == i then
														UiTranslate(buttonWid-54, 15)
														UiScale(1.5)
														UiColor(0, 1, 0)
														UiImage("ui/hud/checkmark.png")
													end
												end
											end
										else
											UiTranslate(buttonWid-54, 15)
											UiColor(1, 1, 1)
											UiImage("ui/terminal/map_x.png")
										end
									UiPop()
									if UiBlankButton(buttonWid, 100) and canSelect then
										ResetRGB()
										if selectSection == 3 then
											if selectionList[3] == i then
												selectionList[3] = 0
											else
												selectionList[3] = i
											end
										elseif selectSection == 5 then

											if lastClick == i then
												local content = selectionList[5]
												local exist = false
												local atPos = 0

												for c=1, #content do
													if content[c][1] == i then
														exist = true
														atPos = c
														break
													end
												end

												if not exist then
													if blackListMain then
														local tempCheck1 = {}
														local tempCheck2 = {}
														local currBlackList = blackListMain.p5

														if currBlackList then
															for c=1, #compChecklist do
																local matched = true
																local matchedPos = 0

																if not selectionList[5][c] then
																	selectionList[5][c] = {i, {}, 1}
																end

																for b=1, #currBlackList do
																	if not string.match(compChecklist[c], currBlackList[b]) or selectionList[5][c][1] == i then
																		matchedPos = c
																	else
																		matched = false
																		break
																	end
																end
																if matched then
																	tempCheck1[#tempCheck1+1] = selectionList[5][matchedPos]
																	tempCheck2[#tempCheck2+1] = compChecklist[matchedPos]
																end
															end
															selectionList[5] = tempCheck1
															compChecklist = tempCheck2
														end
													end

													selectionList[5][#selectionList[5]+1] = {i, {}, 1}
													compChecklist[#compChecklist+1] = group[i].id
												else
													table.remove(selectionList[5], atPos)
													table.remove(compChecklist, atPos)
												end
											else
												lastClick = i
											end
										else
											selectionList[selectSection] = i
										end
										if selectSection == 4 then
											colorList = {}
										end
									end
								UiPop()
								UiTranslate(0, 105)
							end
						end
					elseif selectVehicle then
						local group = vehicles
						if choosenVehicle ~= 0 then
							prevChoosen = choosenVehicle
						end
						choosenVehicle = 0

						if #group > 8 then
							buttonWid = 344
							local length = (#group+1)*105
							local windowH = UiHeight()

							if UiIsMouseInRect(UiWidth(), UiHeight()) and not InputDown("lmb") then
								slidePos = slidePos - InputValue("mousewheel")*25
							end

							slidePos = math.min(length-windowH, math.max(0, slidePos))
							if not clicked then
								SetValue("slideValue", slidePos, "cosine", 0.05)
							end

							UiPush()
								UiTranslate(UiWidth(), 0)
								UiAlign("top right")
								UiColor(0.2, 0.2, 0.2, 0.4)
								UiImageBox("ui/common/box-solid-6.png", 20, UiHeight(), 4, 4)
								UiTranslate(-2, 2+slideValue*windowH/length)

								local slideBarL = windowH*windowH/length-4

								if (UiIsMouseInRect(16, slideBarL) or clicked) and InputDown("lmb") then
									slideValue = slideValue + InputValue("mousedy")*length/windowH
									slideValue = math.min(length-windowH, math.max(0, slideValue))
									slidePos = slideValue
									clicked = true
									UiColor(0.5, 0.5, 0.5)
								else
									clicked = false
									if UiIsMouseInRect(16, slideBarL) then
										UiColor(0.8, 0.8, 0.8)
									else
										UiColor(0.7, 0.7, 0.7)
									end
								end
								UiImageBox("ui/common/box-solid-6.png", 16, slideBarL, 4, 4)
							UiPop()
							UiTranslate(0, -slideValue)
						else
							buttonWid = 364
						end

						if #group == 0 then
							UiTranslate(190, 300)
							UiAlign("middle center")
							UiFont("bold.ttf", 40)
							UiColor(1, 0.6, 0, 0.5)
							UiText("No Vehicles Found")
						else
							UiTranslate(8, 8)
							UiButtonPressDist(0)
							UiButtonPressColor(0.3, 0.7, 0.3)
							for i=1, #group do
								UiPush()
									UiButtonImageBox("ui/common/score-frame-7.png", 21, 21, 0.85, 0.85, 0.85)
									UiButtonHoverColor(0.4, 1, 0.4)
									UiColor(1, 1, 1)
									UiPush()
										UiTranslate(5, 10)
										UiPush()
											UiFont("bold.ttf", 30)
											local compName = group[i][1] or "unnamed"
											if string.len(compName) > 28 then
												compName = string.sub(compName, 1, 28)
											end
											if compName == "" then compName = "unnamed" end
											UiText(compName)
										UiPop()
										UiTranslate(2, 33)
										UiPush()
											UiFont("regular.ttf", 22)
											local compDesc = group[i][2] or ""
											local textW = UiGetTextSize(compDesc)
											UiWordWrap(buttonWid-28)
											UiText(compDesc)
										UiPop()
									UiPop()
									if UiBlankButton(buttonWid, 100) then
										ResetRGB()
										choosenVehicle = i
										if choosenVehicle ~= prevChoosen then
											selectionList = {1, 1, 0, 1, {}}
											for n=1, 4 do
												if n ~= 3 then
													selectionList[n] = math.min(#vehicles[choosenVehicle][3][n], 1)
												end
											end
											compChecklist = {}
											colorList = {}
											prevChoosen = 0
										end
										selectVehicle = false
										inSection = true
									end
								UiPop()
								UiTranslate(0, 105)
							end
						end
					elseif showList then
						if #savedList > 6 then
							buttonWid = 344
							local length = (#savedList)*135+80
							local windowH = UiHeight()

							if UiIsMouseInRect(UiWidth(), UiHeight()) and not InputDown("lmb") then
								slidePos = slidePos - InputValue("mousewheel")*25
							end

							slidePos = math.min(length-windowH, math.max(0, slidePos))
							if not clicked then
								SetValue("slideValue", slidePos, "cosine", 0.05)
							end

							UiPush()
								UiTranslate(UiWidth(), 0)
								UiAlign("top right")
								UiColor(0.2, 0.2, 0.2, 0.4)
								UiImageBox("ui/common/box-solid-6.png", 20, UiHeight(), 4, 4)
								UiTranslate(-2, 2+slideValue*windowH/length)

								local slideBarL = windowH*windowH/length-4

								if (UiIsMouseInRect(16, slideBarL) or clicked) and InputDown("lmb") then
									slideValue = slideValue + InputValue("mousedy")*length/windowH
									slideValue = math.min(length-windowH, math.max(0, slideValue))
									slidePos = slideValue
									clicked = true
									UiColor(0.5, 0.5, 0.5)
								else
									clicked = false
									if UiIsMouseInRect(16, slideBarL) then
										UiColor(0.8, 0.8, 0.8)
									else
										UiColor(0.7, 0.7, 0.7)
									end
								end
								UiImageBox("ui/common/box-solid-6.png", 16, slideBarL, 4, 4)
							UiPop()
							UiTranslate(0, -slideValue)
						else
							buttonWid = 364
						end

						if #savedList == 0 then
							UiTranslate(190, 300)
							UiAlign("middle center")
							UiFont("bold.ttf", 40)
							UiColor(1, 0.6, 0, 0.5)
							UiText("No Vehicles Found")
						else
							UiTranslate(8, 8)
							UiButtonPressDist(0)
							UiButtonPressColor(0.3, 0.7, 0.3)
							for i=1, #savedList do
								UiPush()
									if selectSaved == i then
										UiButtonImageBox("ui/common/score-frame-7.png", 21, 21, 0.25, 1, 0.25)
										if shortCodeStr == "" and shortCode then
											shortCodeStr = GenerateShortCode(savedList[selectSaved].listPos)
										end
									else
										UiButtonImageBox("ui/common/score-frame-7.png", 21, 21, 0.85, 0.85, 0.85)
									end
									UiButtonHoverColor(0.4, 1, 0.4)
									UiColor(1, 1, 1)
									UiPush()
										UiTranslate(5, 10)
										UiPush()
											UiFont("bold.ttf", 30)
											local compName = savedList[i].name
											if compName == "" then compName = "Unnamed Vehicle" end
											if string.len(compName) > 25 then
												compName = string.sub(compName, 1, 25)
											end
											UiText(compName)
										UiPop()
										UiTranslate(2, 35)
										UiPush()
											UiFont("regular.ttf", 25)
											local modelIndex = savedList[i].model or 1
											modelIndex = math.max(modelIndex, 1)
											local modelName = vehicles[modelIndex][1]
											UiWordWrap(buttonWid-20)
											UiText("Model: "..modelName)
										UiPop()
										UiTranslate(0, 27)
										UiPush()
											UiColor(0.8, 0.8, 0.8)
											UiFont("regular.ttf", 22)
											local compDesc = savedList[i].desc
											UiWordWrap(buttonWid-20)
											UiText(compDesc)
										UiPop()
									UiPop()
									if UiBlankButton(buttonWid, 130) then
										selectSaved = i
										canLoad = true
										shortCodeStr = ""
									end
								UiPop()
								UiTranslate(0, 135)
							end
						end
					end
				UiPop()
				UiPush() -- left 9 pics & version
					UiTranslate(-230, 0)
					UiAlign("top left")
					UiButtonPressDist(0.1)

					if selectVehicle then
						UiButtonImageBox("ui/common/box-outline-4.png", 10, 10)
						UiButtonHoverColor(1, 1, 1)
						UiColor(1, 0.6, 0.3)
						UiImageButton("pics/pic0.png")
					else
						UiButtonImageBox("ui/common/box-outline-4.png", 10, 10, 0.85, 0.85, 0.85)
						UiButtonHoverColor(0.4, 1, 0.4)
						UiColor(0.8, 0.8, 0.8)
						if UiImageButton("pics/pic0.png") then
							ResetRGB()
							selectVehicle = true
							inSection = false
							showList = false
						end
					end

					UiTranslate(0, 82)
					UiColor(0.5, 0.5, 0.5)
					UiRect(70, 3)
					UiTranslate(0, 15)

					for b=1, 5 do
						if selectSection == b and inSection then
							UiButtonImageBox("ui/common/box-outline-4.png", 10, 10)
							UiButtonHoverColor(1, 1, 1)
							UiColor(1, 0.6, 0.3)
							UiImageButton("pics/pic"..b..".png")
						else
							if choosenVehicle == 0 then
								UiButtonImageBox("ui/common/box-outline-4.png", 10, 10, 0.95, 0.65, 0.15)
								UiButtonHoverColor(1, 0.8, 0.4)
								UiColor(1, 0.7, 0.2)
								UiImageButton("pics/pic"..b..".png")
							else
								UiButtonImageBox("ui/common/box-outline-4.png", 10, 10, 0.85, 0.85, 0.85)
								UiButtonHoverColor(0.4, 1, 0.4)
								UiColor(0.8, 0.8, 0.8)
								if UiImageButton("pics/pic"..b..".png") then
									ResetRGB()
									selectSection = b
									slidePos = 0
									slideValue = 0
									selectVehicle = false
									inSection = true
									showList = false
								end
							end
						end
						UiTranslate(0, 75)
					end
					UiTranslate(0, 7)
					UiColor(0.5, 0.5, 0.5)
					UiRect(70, 3)
					UiTranslate(0, 15)

					UiButtonImageBox("ui/common/box-outline-4.png", 10, 10, 0.85, 0.85, 0.85)
					UiButtonHoverColor(0.4, 1, 0.4)
					if canSpawn and choosenVehicle ~= 0 then
						UiColor(0.3, 0.9, 0.3)
						if UiImageButton("pics/pic6.png") then
							saveVehicle = true
						end
					else
						UiColor(0.8, 0.8, 0.8)
						UiImageButton("pics/pic6.png")
					end

					UiTranslate(0, 75)

					if showList then
						UiButtonImageBox("ui/common/box-outline-4.png", 10, 10, 0.25, 0.75, 1)
					end
					UiButtonHoverColor(0.4, 0.8, 1)
					UiColor(0.3, 0.7, 0.9)
					if UiImageButton("pics/pic7.png") and not showList then
						showList = true
						slidePos = 0
						slideValue = 0
						selectVehicle = false
						inSection = false
					end

					UiTranslate(0, 82)
					UiColor(0.5, 0.5, 0.5)
					UiRect(70, 3)
					UiTranslate(0, 15)

					if GetPlayerVehicle() == 0 then
						UiButtonImageBox("ui/common/box-outline-4.png", 10, 10)
						UiButtonHoverColor(1, 0.4, 0.4)
						UiColor(1, 0.2, 0.2)
						UiImageButton("pics/pic8.png")
					else
						UiButtonImageBox("ui/common/box-outline-4.png", 10, 10, 0.85, 0.85, 0.85)
						UiButtonHoverColor(0.4, 1, 0.4)
						if freeCam then
							UiColor(0.2, 1, 0.2)
						else
							UiColor(0.8, 0.8, 0.8)
						end
						if UiImageButton("pics/pic8.png") and not freeCam then
							ResetRGB()
							freeCam = true
						end
					end
					UiTranslate(0, 82)
					UiColor(0.5, 0.5, 0.5)
					UiRect(70, 3)
					UiTranslate(0, 15)

					UiPush()
						local infoSize = 70
						local popupSize = 240
						UiAlign("middle center")
						UiTranslate(infoSize/2, infoSize/2)
						UiColorFilter(1, 1, 1, 0.75)
						UiFont("regular.ttf", 18)
						if latestVersion ~= VERSION then
							UiButtonImageBox("ui/common/box-outline-4.png", 6, 6, 0.85, 0.45, 0)
							UiColor(0.9, 0.5, 0)
							UiText("YLVF\nToolkit\nV"..VERSION)
							if UiBlankButton(infoSize, infoSize) then
								ResetRGB()
								showNotice = true
								fade = 1.7
							end
						else
							UiColor(0.6, 1, 0.6)
							UiText("YLVF\nToolkit\nV"..VERSION)
							UiColor(0.15, 1, 0.15)
							UiImageBox("ui/common/box-outline-4.png", infoSize, infoSize, 6, 6)
						end

						if showNotice and fade > 0 then
							if fade == 1.7 then
								SetValue("fade", 0, "easein", 5.5)
							end
							UiTranslate((infoSize+popupSize+22)/2, 0)
							UiColorFilter(1, 1, 1, math.min(1, fade))
							UiColor(0.1, 0.1, 0.1, 0.6)
							UiImageBox("ui/common/box-solid-4.png", popupSize, infoSize, 6, 6)
							UiColor(1, 1, 1)
							UiWordWrap(popupSize-15)
							UiText("This menu isn't using the latest version of YLVF Toolkit\nContact pack creator for update")
						else
							showNotice = false
						end
					UiPop()

					UiTranslate(0, 82)
					UiColor(0.5, 0.5, 0.5)
					UiRect(70, 3)
				UiPop()
				UiTranslate(0, 910)
				UiAlign("bottom left")
				UiPush() -- load / preview / spawn
					if showList then
						UiPush() -- Delete
							UiTranslate(-225, 0)
							UiButtonImageBox("ui/common/score-frame-7.png", 15, 15)
							UiFont("bold.ttf", 30)
	
							if selectSaved ~= 0 and canLoad then
								UiButtonHoverColor(1, 0.2, 0.2)
								UiColor(1, 0.8, 0.2)
								if UiTextButton("Delete", 110, 45) then
									showDelete = true
								end
							else
								UiButtonHoverColor(1, 0.7, 0.4)
								UiColor(1, 0.6, 0)
								UiTextButton("Delete", 110, 45)
							end
						UiPop()
						UiPush() -- Edit
							UiTranslate(-105, 0)
							UiButtonImageBox("ui/common/score-frame-7.png", 15, 15)
							UiFont("bold.ttf", 30)
	
							if selectSaved ~= 0 and canLoad then
								UiButtonHoverColor(0, 1, 1)
								UiColor(1, 1, 1)
								if UiTextButton("Edit", 100, 45) then
									editVehicle = true
									newNameChange = savedList[selectSaved].name
									newDescChange = savedList[selectSaved].desc
								end
							else
								UiButtonHoverColor(1, 0.7, 0.4)
								UiColor(1, 0.6, 0)
								UiTextButton("Edit", 100, 45)
							end
						UiPop()
						UiPush() -- Load & Preview
							UiTranslate(5, 0)
							UiButtonImageBox("ui/common/score-frame-7.png", 15, 15)
							UiFont("bold.ttf", 30)
	
							if selectSaved ~= 0 and canLoad then
								UiButtonHoverColor(0.2, 1, 0.2)
								UiColor(1, 1, 1)
								if UiTextButton("Load & Preview", 220, 45) then
									selectionList, colorList, choosenVehicle = LoadVehicleData(savedList[selectSaved].listPos)
									compChecklist = GenerateCheckList(selectionList[5], choosenVehicle)
									selectionList, compChecklist, lastClick = CheckCompatibilty(choosenVehicle, selectionList, compChecklist, lastClick)
									if previewList ~= {} or previewList[1] ~= nil then
										SetPlayerVehicle(0)
										for l=#previewList, 1, -1 do
											if IsHandleValid(previewList[l]) then
												Delete(previewList[l])
											end
										end
									end
									freeCam = true

									for n=1, 4 do
										rawset(previousList, n, selectionList[n])
									end
									for n = math.max(#selectionList[5], #previousList[5]), 1, -1 do
										if selectionList[5][n] then
											previousList[5][n] = {1, {}, 1}
											for k=1, 3 do
												if k == 2 then
													for m=1, #selectionList[5][n][k] do
														table.insert(previousList[5][n][k], selectionList[5][n][k][m])
													end
												else
													rawset(previousList[5][n], k, selectionList[5][n][k])
												end
											end
										else
											table.remove(previousList[5])
										end
									end
									for n = math.max(#colorList, #previousList[6]), 1, -1 do
										if colorList[n] then
											if previousList[6][n] then
												rawset(previousList[6], n, colorList[n])
											else
												table.insert(previousList[6], n, colorList[n])
											end
										else
											table.remove(previousList[6])
										end
									end
									
									previewTrans, previewList = PreviewVehicle(ConstructVehicle(choosenVehicle, selectionList, colorList), previewTrans)
								end
							else
								UiButtonHoverColor(1, 0.7, 0.4)
								UiColor(1, 0.6, 0)
								UiTextButton("Load & Preview", 220, 45)
							end
						UiPop()
					else
						canSpawn = selectionList[1] > 0 and selectionList[2] > 0 and selectionList[4] > 0
						UiPush() -- Preview
							UiTranslate(-5, 0)
							UiButtonImageBox("ui/common/score-frame-7.png", 15, 15)
							UiFont("bold.ttf", 30)

							for o=1, 1 do
								if choosenVehicle ~= 0 and canSpawn then
									selectionList, compChecklist, lastClick = CheckCompatibilty(choosenVehicle, selectionList, compChecklist, lastClick)
									canSpawn = selectionList[1] > 0 and selectionList[2] > 0 and selectionList[4] > 0

									if not canSpawn then
										break
									end

									UiButtonHoverColor(0, 1, 1)
									UiColor(1, 1, 1)

									local sameList = true
									local sameColor = true
									for n=1, 4 do
										if not rawequal(previousList[n], selectionList[n]) then
											sameList = false
											sameColor = not (n == 4)
											break
										end
									end
									if #selectionList[5] == #previousList[5] then
										for n=1, math.min(#selectionList[5], #previousList[5]) do
											for k=1, 3 do
												if k == 2 then
													for m=1, #selectionList[5][n][k] do
														if not rawequal(previousList[5][n][k][m], selectionList[5][n][k][m]) then
															sameList = false
															break
														end
													end
												else
													if not rawequal(previousList[5][n][k], selectionList[5][n][k]) then
														sameList = false
														break
													end
												end
											end
											if not sameList then
												break
											end
										end
									else
										sameList = false
									end
									if #colorList == #previousList[6] then
										for n=1, math.min(#colorList, #previousList[6]) do
											if not rawequal(previousList[6][n], colorList[n]) then
												sameList = false
												break
											end
										end
									else
										sameList = false
									end

									if not advPre then
										if not (sameList or colorDone) and sameColor then
											sameList = true
										end
									end

									if UiTextButton("Preview", 110, 45) then
										ResetRGB()
										if previewList ~= {} or previewList[1] ~= nil then
											SetPlayerVehicle(0)
											for l=#previewList, 1, -1 do
												if IsHandleValid(previewList[l]) then
													Delete(previewList[l])
												end
											end
										end
										freeCam = true

										for n=1, 4 do
											rawset(previousList, n, selectionList[n])
										end
										for n = math.max(#selectionList[5], #previousList[5]), 1, -1 do
											if selectionList[5][n] then
												previousList[5][n] = {1, {}, 1}
												for k=1, 3 do
													if k == 2 then
														for m=1, #selectionList[5][n][k] do
															table.insert(previousList[5][n][k], selectionList[5][n][k][m])
														end
													else
														rawset(previousList[5][n], k, selectionList[5][n][k])
													end
												end
											else
												table.remove(previousList[5])
											end
										end
										for n = math.max(#colorList, #previousList[6]), 1, -1 do
											if colorList[n] then
												if previousList[6][n] then
													rawset(previousList[6], n, colorList[n])
												else
													table.insert(previousList[6], n, colorList[n])
												end
											else
												table.remove(previousList[6])
											end
										end
										
										previewTrans, previewList = PreviewVehicle(ConstructVehicle(choosenVehicle, selectionList, colorList), previewTrans)

									elseif autoPre and not sameList then
										if previewList ~= {} or previewList[1] ~= nil then
											SetPlayerVehicle(0)
											for l=#previewList, 1, -1 do
												if IsHandleValid(previewList[l]) then
													Delete(previewList[l])
												end
											end
										end

										for n=1, 4 do
											rawset(previousList, n, selectionList[n])
										end
										for n = math.max(#selectionList[5], #previousList[5]), 1, -1 do
											if selectionList[5][n] then
												previousList[5][n] = {1, {}, 1}
												for k=1, 3 do
													if k == 2 then
														for m=1, #selectionList[5][n][k] do
															table.insert(previousList[5][n][k], selectionList[5][n][k][m])
														end
													else
														rawset(previousList[5][n], k, selectionList[5][n][k])
													end
												end
											else
												table.remove(previousList[5])
											end
										end
										for n = math.max(#colorList, #previousList[6]), 1, -1 do
											if colorList[n] then
												if previousList[6][n] then
													rawset(previousList[6], n, colorList[n])
												else
													table.insert(previousList[6], n, colorList[n])
												end
											else
												table.remove(previousList[6])
											end
										end

										previewTrans, previewList = PreviewVehicle(ConstructVehicle(choosenVehicle, selectionList, colorList), previewTrans)
									end
								else
									UiButtonHoverColor(1, 0.7, 0.4)
									UiColor(1, 0.6, 0)
									UiTextButton("Preview", 110, 45)
								end
							end
						UiPop()
						UiPush() -- Spawn
							UiTranslate(115, 0)
							UiButtonImageBox("ui/common/score-frame-7.png", 15, 15)
							UiFont("bold.ttf", 30)
							if previewList == {} or previewList[1] == nil then
								buttonText = "Spawn"
							else
								buttonText = "Confirm"
							end

							if choosenVehicle ~= 0 and canSpawn then
								selectionList, compChecklist, lastClick = CheckCompatibilty(choosenVehicle, selectionList, compChecklist, lastClick)
								UiButtonHoverColor(0, 1, 0)
								UiColor(0.4, 1, 0.4)
								if UiTextButton(buttonText, 110, 45) then
									ResetRGB()
									if previewList == {} or previewList[1] == nil then
										SpawnVehicle(ConstructVehicle(choosenVehicle, selectionList, colorList))
									end
									SetBool("YLVF.packs."..packIndex..".active", false)
									SetBool("YLVF.pack.sub", false)
									previewList = {}
									previewTrans = {}
								end
							else
								UiButtonHoverColor(1, 0.7, 0.4)
								UiColor(1, 0.6, 0)
								UiTextButton(buttonText, 110, 45)
							end
						UiPop()
					end
				UiPop()
				if inSection then -- additional options --
					if selectSection == 4 then
						local index = selectionList[4]
						if vehicles[choosenVehicle][3][4][index] then
							local colorNum = vehicles[choosenVehicle][3][4][index].slot or 1
							changeColor = math.min(changeColor, colorNum)

							for i=1, colorNum do
								if not colorList[i] then
									colorList[#colorList+1] = DecToHex(math.random(0, 255))..DecToHex(math.random(0, 255))..DecToHex(math.random(0, 255))
								end
							end

							UiPush()
								UiTranslate(250, 15)
								UiColor(0, 0, 0, 0.55)
								UiImageBox("ui/common/box-solid-4.png", 400, 300, 15, 15)
								UiAlign("top left")
								UiTranslate(15, -290)
								UiPush()
									UiTranslate(25, 25)
									UiAlign("middle center")
									UiButtonPressDist(0)
									for i=1, colorNum do
										UiColor(0.2, 0.2, 0.2, 0.5)
										UiRect(44, 39)
										UiHexColor(colorList[i])
										UiRect(38, 33)
										if changeColor == i then
											UiButtonHoverColor(0.1, 1, 0.1)
											UiButtonImageBox("ui/common/score-frame-7.png", 15, 15, 0.2, 1, 0.2)
											UiFont("bold.ttf", 26)
										else
											UiButtonHoverColor(0.9, 0.9, 0.9)
											UiButtonImageBox("ui/common/score-frame-7.png", 15, 15, 0.75, 0.75, 0.75)
											UiFont("regular.ttf", 26)
										end
										UiColor(0, 0, 0, 0.6)
										UiRect(20, 24)
										UiColor(1, 1, 1)
										if UiTextButton(i, 48, 43) then
											changeColor = i
											ResetRGB()
										end
										UiTranslate(58, 0)
									end
								UiPop()
								UiTranslate(0, 54)
								UiPush()
									UiColor(0.55, 0.55, 0.55, 0.8)
									UiAlign("top left")
									UiRect(370, 4)
								UiPop()
								UiPush()
									UiTranslate(10, 12)
									UiHexColor(colorList[changeColor])
									UiRect(82, 90)
									UiPush()
										UiTranslate(25, 120)
										colorList[changeColor], colorDone = DrawRGBselecter(colorList[changeColor])
									UiPop()
									UiPush()
										UiTranslate(92, 0)

										UiPush()
											UiPush()
												UiColor(0, 0, 0, 0.5)
												UiRect(258, 44)
											UiPop()

											UiPush()
												UiTranslate(2, 2)
												if UiIsMouseInRect(20, 40) then
													if InputDown("lmb") then
														UiColor(0.35, 1, 0.35, 0.8)
														colorTrans = colorTrans - moveSpeed
													else
														UiColor(0.5, 0.75, 0.5, 0.75)
													end
												else
													UiColor(0.5, 0.5, 0.5, 0.75)
												end
												UiRect(20, 40)
												UiColor(1, 1, 1)
												UiAlign("middle center")
												UiTranslate(10, 21)
												UiScale(0.75, 1.5)
												UiRotate(180)
												UiImage("ui/common/play.png")
											UiPop()

											UiPush()
												UiTranslate(236, 2)
												if UiIsMouseInRect(20, 40) then
													if InputDown("lmb") then
														UiColor(0.35, 1, 0.35, 0.8)
														colorTrans = colorTrans + moveSpeed
													else
														UiColor(0.5, 0.75, 0.5, 0.75)
													end
												else
													UiColor(0.5, 0.5, 0.5, 0.75)
												end
												UiRect(20, 40)
												UiColor(1, 1, 1)
												UiAlign("middle center")
												UiTranslate(10, 19)
												UiScale(0.75, 1.5)
												UiImage("ui/common/play.png")
											UiPop()

											colorTrans = math.max(0, math.min(slotNum*58-220, colorTrans))
											local diffVal = math.abs(colorTrans - colorPos)

											if diffVal ~= 0 then
												if diffVal > 10 then
													closeVal = false
													SetValue("colorPos", colorTrans, "linear", math.abs(colorTrans - colorPos)/500)
												else
													if not closeVal then
														SetValue("colorPos", colorTrans, "linear", 0.1)
														closeVal = true
													end
												end
											else
												closeVal = false
											end
												
											UiTranslate(24, 0)

											UiWindow(210, 44, true)
											if UiIsMouseInRect(210, 44) then
												colorTrans = colorTrans - InputValue("mousewheel")*moveSpeed
											end
											UiTranslate(24-colorPos, 22)
											UiAlign("middle center")

											UiButtonPressDist(0)
											for c=1, slotNum do
												UiColor(0.2, 0.2, 0.2, 0.5)
												UiRect(44, 39)
												UiHexColor(savedColor[c])
												UiRect(38, 33)
												if presetColor == c then
													UiButtonHoverColor(0.1, 1, 0.1)
													UiButtonImageBox("ui/common/score-frame-7.png", 15, 15, 0.2, 1, 0.2)
													UiFont("bold.ttf", 26)
												else
													UiButtonHoverColor(0.9, 0.9, 0.9)
													UiButtonImageBox("ui/common/score-frame-7.png", 15, 15, 0.75, 0.75, 0.75)
													UiFont("regular.ttf", 26)
												end
												UiColor(0, 0, 0, 0.6)
												UiRect(20, 24)
												UiColor(1, 1, 1)
												if UiTextButton(c, 48, 43) then
													if presetColor == c then
														presetColor = 0
													else
														presetColor = c
													end
													ResetRGB()
												end
												UiTranslate(58, 0)
											end
										UiPop()

										UiTranslate(12, 50)
										UiButtonImageBox("ui/common/score-frame-7.png", 10, 10, 0.85, 0.85, 0.85)
										UiColor(0.8, 0.8, 0.8)

										UiPush()
											UiButtonHoverColor(0.4, 1, 0.4)
											UiScale(0.6)
											if UiImageButton("pics/pic10.png") then
												colorList[changeColor] = DecToHex(math.random(0, 255))..DecToHex(math.random(0, 255))..DecToHex(math.random(0, 255))
												colorDone = true
											end
										UiPop()
										UiTranslate(60, 0)

										UiPush()
											UiColor(0.8, 0.8, 0.8, 0.5)
											UiRect(5, 42)
										UiPop()
										UiTranslate(23, 0)

										UiPush()
											if presetColor ~= 0 then
												UiColor(0.3, 0.6, 1)
												UiButtonHoverColor(0.3, 0.7, 1)
											end
											UiScale(0.6)
											if UiImageButton("pics/pic6.png") then
												SetBool("YLVF.colors.done", false)
												SetInt("YLVF.colors.changePos", presetColor)
												SetString("YLVF.colors.slot."..presetColor, colorList[changeColor])
												savedColor[presetColor] = colorList[changeColor]
											end
										UiPop()
										UiTranslate(55, 0)

										UiPush()
											if presetColor ~= 0 then
												UiColor(0.3, 1, 0.3)
												UiButtonHoverColor(0.4, 1, 0.4)
											end
											UiScale(0.6)
											if UiImageButton("pics/pic7.png") then
												colorList[changeColor] = savedColor[presetColor]
												colorDone = true
											end
										UiPop()
										UiTranslate(55, 0)

										UiPush()
											if presetColor ~= 0 then
												UiColor(1, 0.6, 0.4)
												UiButtonHoverColor(1, 0.4, 0.4)
											end
											UiScale(0.6)
											if UiImageButton("pics/pic9.png") then
												SetBool("YLVF.colors.done", false)
												SetInt("YLVF.colors.changePos", presetColor)
												SetString("YLVF.colors.slot."..presetColor, "5A5A5A")
												savedColor[presetColor] = "5A5A5A"
											end
										UiPop()
									UiPop()
								UiPop()
							UiPop()
						end
					else
						colorDone = true
					end
					if selectSection == 5 then
						local tempList = selectionList[5]
						local index = lastClick
						local statusList = {}
						local colorSlot = 0
						local atPos = 0

						for i=1, #tempList do
							if tempList[i][1] == index then
								statusList = tempList[i][2]
								colorSlot = i
								atPos = i
							end
						end

						for i=1, 1 do
							if index > 0 and vehicles[choosenVehicle][3][5][index] then
								local compMain = vehicles[choosenVehicle][3][5][index].xmlData
								local compMainName = vehicles[choosenVehicle][3][5][index].name

								if type(compMain) == "table" then
									local noOptions = compMain[1].noOption
									local paintable = compMain[1].canPaint
									local optionalNum = #compMain-1
									local maxLen = 0

									if noOptions and paintable == nil then
										if atPos ~= 0 then
											local tempList2 = {}
											for t=1, #compMain-1 do
												table.insert(tempList2, true)
											end
											rawset(selectionList[5][atPos], 2, tempList2)
										end
										break
									end

									UiPush()
										UiFont("regular.ttf", 29)
										local widTitle, higTitle = UiGetTextSize("Optional for "..compMainName)
									UiPop()

									for t=1, optionalNum do
										if noOptions then
											if compMain[t+1].group then
												local posIndex = compMain[t+1].group
												statusList[posIndex] = t+1
											else
												statusList[t] = true
											end
										else
											UiPush()
												UiFont("regular.ttf", 26)
												local wid, hig = UiGetTextSize(compMain[t+1].name)
												maxLen = math.max(maxLen, wid)
											UiPop()
										end
									end

									local panelW = math.max(widTitle+20, maxLen+100)
									local panelH = 45*optionalNum + 65 + ((paintable and 63) or 0)

									if noOptions then
										panelH = panelH - 45*optionalNum - 14
									end

									UiPush()
										UiTranslate(250, 15)
										UiColor(0, 0, 0, 0.55)
										UiImageBox("ui/common/box-solid-4.png", panelW, panelH, 15, 15)
										UiAlign("top left")
										UiTranslate(10, 10-panelH)
										UiFont("regular.ttf", 29)
										UiColor(0.95, 0.95, 0.95)
										UiText("Optional for "..compMainName)
										UiTranslate(0, 33)
										UiPush()
											UiColor(0.5, 0.5, 0.5, 0.8)
											UiRect(panelW-20, 4)
										UiPop()

										if paintable then
											local index = selectionList[4] or 1
											local colorNum = vehicles[choosenVehicle][3][4][index].slot or 1
											local canChangeColor = selectionList[5][colorSlot]

											if canChangeColor then
												changeColor = selectionList[5][colorSlot][3]
											end
											changeColor = math.min(changeColor, colorNum)

											for i=1, colorNum do
												if not colorList[i] then
													colorList[#colorList+1] = DecToHex(math.random(0, 255))..DecToHex(math.random(0, 255))..DecToHex(math.random(0, 255))
												end
											end

											UiPush()
												UiTranslate(30, 32)
												UiAlign("middle center")
												UiButtonPressDist(0)
												for i=1, colorNum do
													UiColor(0.2, 0.2, 0.2, 0.5)
													UiRect(44, 39)
													UiHexColor(colorList[i])
													UiRect(38, 33)
													if changeColor == i then
														UiButtonHoverColor(0.1, 1, 0.1)
														UiButtonImageBox("ui/common/score-frame-7.png", 15, 15, 0.2, 1, 0.2)
														UiFont("bold.ttf", 26)
													else
														UiButtonHoverColor(0.9, 0.9, 0.9)
														UiButtonImageBox("ui/common/score-frame-7.png", 15, 15, 0.75, 0.75, 0.75)
														UiFont("regular.ttf", 26)
													end
													UiColor(0, 0, 0, 0.6)
													UiRect(20, 24)
													UiColor(1, 1, 1)
													if UiTextButton(i, 48, 43) and canChangeColor then
														changeColor = i
														selectionList[5][colorSlot][3] = i
													end
													UiTranslate(56, 0)
												end
											UiPop()
										end

										if (not noOptions) and compMain[1].canPaint then
											UiTranslate(0, 62)
											UiPush()
												UiColor(0.5, 0.5, 0.5, 0.8)
												UiRect(panelW-20, 2)
											UiPop()
											UiTranslate(0, 2)
										end

										if not noOptions then

											UiTranslate(10, 16)
											statusList = DrawSubOptional(optionalNum, compMain, statusList, (atPos == 0))
								
											if atPos ~= 0 then
												rawset(selectionList[5][atPos], 2, statusList)
											end
										end
									UiPop()
								end
							end
						end
					end
				end
				if blurVal > 0 then -- delete warning --
					UiModalBegin()
						if InputPressed("pause") then
							showDelete = false
						end
						UiBlur(blurVal)
						UiPush()
							UiTranslate(700, -505)
							UiAlign("middle center")
							UiColorFilter(1, 1, 1, blurVal*1.8)
							UiColor(0, 0, 0, 0.8)
							UiImageBox("ui/common/box-solid-4.png", 400, 200, 15, 15)
							UiPush()
								UiTranslate(0, -36)
								UiColor(1, 0.4, 0.2)
								UiFont("bold.ttf", 36)
								UiWordWrap(360)
								UiText("Are you sure to delete this vehicle from savegame?")
							UiPop()
							UiTranslate(0, 48)
							UiPush()
								UiTranslate(-70, 0)
								UiButtonImageBox("ui/common/optionsbox.png", 15, 15)
								UiButtonHoverColor(0.4, 1, 0.4)
								UiFont("bold.ttf", 30)
								UiColor(1, 1, 1)
								if UiTextButton("No", 90, 45) then
									showDelete = false
								end
							UiPop()
							UiPush()
								UiTranslate(70, 0)
								UiButtonImageBox("ui/common/optionsbox.png", 15, 15)
								UiButtonHoverColor(1, 0.1, 0.1)
								UiFont("bold.ttf", 30)
								UiColor(1, 0.6, 0.2)
								if UiTextButton("Yes", 90, 45) then
									local removePos = savedList[selectSaved].listPos
									local exist = false
									for i=1, #emptySlot do
										if emptySlot[i] == removePos then
											exist = true
										end
									end
									if not exist then
										emptySlot[#emptySlot+1] = removePos
									end
									ClearKey("savegame.mod.vehicles."..removePos)
									table.remove(savedList, selectSaved)
									showDelete = false
									selectSaved = 0
								end
							UiPop()
						UiPop()
					UiModalEnd()
				end
				if blurVal2 > 0 then -- save vehicle --
					local winW = 400
					local winH = 400
					local gap = 16
					UiModalBegin()
						if InputPressed("pause") then
							saveVehicle = false
						end
						UiBlur(blurVal2)
						UiPush()
							UiTranslate(700, -505)
							UiAlign("middle center")
							UiColorFilter(1, 1, 1, blurVal2*3.6)
							UiColor(0, 0, 0, 0.8)
							UiImageBox("ui/common/box-solid-4.png", winW, winH, 15, 15)

							UiAlign("top left")
							UiTranslate(gap-winW/2, gap-winH/2)
							UiPush()
								UiAlign("top center")
								UiTranslate(winW/2-16, 0)
								UiColor(1, 1, 1)
								UiFont("bold.ttf", 42)
								UiText("Save New Vehicle")
							UiPop()

							UiTranslate(0, 40)
							UiPush()
								UiColor(0.5, 0.5, 0.5)
								UiRect(winW-2*gap, 4)
							UiPop()

							UiTranslate(0, 10)
							UiPush()
								UiTranslate(8, 8)
								UiColor(1, 1, 1)
								UiFont("bold.ttf", 32)
								UiText("Name: *")

								UiPush()
									UiAlign("bottom right")
									UiTranslate(winW-gap*2-16, 29)
									UiFont("regular.ttf", 24)
									local nameLength = string.len(newName)
									if nameLength >= 25 then
										UiColor(0.8, 0.1, 0.1)
									end
									UiText(nameLength.."/25")
								UiPop()

								UiTranslate(0, 34)
								UiButtonPressDist(0)
								UiButtonPressColor(0.6, 0.6, 0.6)
								UiFont("regular.ttf", 30)
								UiColor(1, 1, 1)

								if editName then
									UiModalBegin()
										UiButtonImageBox("ui/common/box-solid-4.png", 10, 10, 0.2, 0.2, 0.2)
										newName, editName = TypeinText(newName, 25)
										if not UiIsMouseInRect(winW-gap*2-16, 42) then
											if InputPressed("lmb") then editName = false end
										end
									UiModalEnd()
								else
									UiButtonImageBox("ui/common/box-solid-4.png", 10, 10, 0.4, 0.4, 0.4)
								end

								local displayName = newName
								if newName == "" then displayName = "Enter Name" end
									
								if UiTextButton(displayName, winW-gap*2-16, 42) and not editDesc then
									editName = not editName
								end
								
								UiTranslate(0, 50)
								
								UiColor(1, 1, 1)
								UiFont("bold.ttf", 32)
								UiText("Description:")

								UiPush()
									UiAlign("bottom right")
									UiTranslate(winW-gap*2-16, 29)
									UiFont("regular.ttf", 24)
									local descLength = string.len(newDesc)
									if descLength >= 80 then
										UiColor(0.8, 0.1, 0.1)
									end
									UiText(descLength.."/80")
								UiPop()

								UiTranslate(0, 34)
								UiButtonPressDist(0)
								UiButtonPressColor(0.6, 0.6, 0.6)
								UiFont("regular.ttf", 28)
								UiColor(1, 1, 1)
								UiWordWrap(winW-gap*2-34)

								if editDesc then
									UiModalBegin()
										UiButtonImageBox("ui/common/box-solid-4.png", 10, 10, 0.2, 0.2, 0.2)
										newDesc, editDesc = TypeinText(newDesc, 80)
										if not UiIsMouseInRect(winW-gap*2-16, 120) then
											if InputPressed("lmb") then editDesc = false end
										end
									UiModalEnd()
								else
									UiButtonImageBox("ui/common/box-solid-4.png", 10, 10, 0.4, 0.4, 0.4)
								end

								local displayDesc = newDesc
								if newDesc == "" then displayDesc = "Enter Description" end
									
								if UiBlankButton(winW-gap*2-16, 120) and not editName then
									editDesc = not editDesc
								end
								UiTranslate(7, 7)
								UiText(displayDesc)
							UiPop()

							UiTranslate(winW/2-gap, winH-92-gap*2)
							UiAlign("top center")
							UiPush()
								UiTranslate(-75, 0)
								UiButtonImageBox("ui/common/box-outline-fill-4.png", 10, 10)
								UiButtonHoverColor(1, 0.1, 0.1)
								UiFont("bold.ttf", 30)
								UiColor(1, 0.6, 0.2)
								if UiTextButton("Cancel", 100, 42) then
									saveVehicle = false
									editName = false
									editDesc = false
								end
							UiPop()
							UiPush()
								UiTranslate(75, 0)
								UiButtonImageBox("ui/common/box-outline-fill-4.png", 10, 10)
								UiFont("bold.ttf", 30)
								if newName ~= "" then
									UiColor(0.3, 1, 0.3)
									UiButtonHoverColor(0.4, 1, 0.4)
									if UiTextButton("Save", 100, 42) then
										local savePosIndex = 0
										if emptySlot[1] then
											savePosIndex = emptySlot[1]
											table.remove(emptySlot, 1)
										else
											savePosIndex = #ListKeys("savegame.mod.vehicles") + 1
										end
										SaveVehicleData(newName, newDesc, savePosIndex, choosenVehicle, selectionList, colorList)
										table.insert(savedList, {name = newName, desc = newDesc, model = choosenVehicle, listPos = savePosIndex})
										saveVehicle = false
										editName = false
										editDesc = false
										newName = ""
										newDesc = ""
									end
								else
									UiColor(0.75, 0.75, 0.75)
									UiButtonHoverColor(1, 0.5, 0)
									UiTextButton("Save", 100, 42)
								end
							UiPop()
						UiPop()
					UiModalEnd()
				end
				if blurVal3 > 0 then -- edit vehicle --
					local winW = 400
					local winH = 430
					local gap = 16
					local disable = true
					if choosenVehicle ~= 0 then disable = false end

					UiModalBegin()
						if InputPressed("pause") then
							editVehicle = false
						end
						UiBlur(blurVal3)
						UiPush()
							UiTranslate(700, -505)
							UiAlign("middle center")
							UiColorFilter(1, 1, 1, blurVal3*3.6)
							UiColor(0, 0, 0, 0.8)
							UiImageBox("ui/common/box-solid-4.png", winW, winH, 15, 15)

							UiAlign("top left")
							UiTranslate(gap-winW/2, gap-winH/2)
							UiPush()
								UiAlign("top center")
								UiTranslate(winW/2-16, 0)
								UiColor(1, 1, 1)
								UiFont("bold.ttf", 42)
								UiText("Edit Vehicle")
							UiPop()

							UiTranslate(0, 40)
							UiPush()
								UiColor(0.5, 0.5, 0.5)
								UiRect(winW-2*gap, 4)
							UiPop()

							UiTranslate(0, 10)
							UiPush()
								UiTranslate(8, 8)
								UiColor(1, 1, 1)
								UiFont("bold.ttf", 32)
								UiText("Name: *")

								UiPush()
									UiAlign("bottom right")
									UiTranslate(winW-gap*2-16, 29)
									UiFont("regular.ttf", 24)
									local nameLength = string.len(newNameChange)
									if nameLength >= 25 then
										UiColor(0.8, 0.1, 0.1)
									end
									UiText(nameLength.."/25")
								UiPop()

								UiTranslate(0, 34)
								UiButtonPressDist(0)
								UiButtonPressColor(0.6, 0.6, 0.6)
								UiFont("regular.ttf", 30)
								UiColor(1, 1, 1)

								if chnageName then
									UiModalBegin()
										UiButtonImageBox("ui/common/box-solid-4.png", 10, 10, 0.2, 0.2, 0.2)
										newNameChange, chnageName = TypeinText(newNameChange, 25)
										if not UiIsMouseInRect(winW-gap*2-16, 42) then
											if InputPressed("lmb") then chnageName = false end
										end
									UiModalEnd()
								else
									UiButtonImageBox("ui/common/box-solid-4.png", 10, 10, 0.4, 0.4, 0.4)
								end

								local displayName = newNameChange
								if newNameChange == "" then displayName = "Enter Name" end
									
								if UiTextButton(displayName, winW-gap*2-16, 42) and not changeDesc then
									chnageName = not chnageName
								end
								
								UiTranslate(0, 50)
								
								UiColor(1, 1, 1)
								UiFont("bold.ttf", 32)
								UiText("Description:")

								UiPush()
									UiAlign("bottom right")
									UiTranslate(winW-gap*2-16, 29)
									UiFont("regular.ttf", 24)
									local descLength = string.len(newDescChange)
									if descLength >= 80 then
										UiColor(0.8, 0.1, 0.1)
									end
									UiText(descLength.."/80")
								UiPop()

								UiTranslate(0, 34)
								UiButtonPressDist(0)
								UiButtonPressColor(0.6, 0.6, 0.6)
								UiFont("regular.ttf", 28)
								UiColor(1, 1, 1)
								UiWordWrap(winW-gap*2-34)

								if changeDesc then
									UiModalBegin()
										UiButtonImageBox("ui/common/box-solid-4.png", 10, 10, 0.2, 0.2, 0.2)
										newDescChange, changeDesc = TypeinText(newDescChange, 80)
										if not UiIsMouseInRect(winW-gap*2-16, 120) then
											if InputPressed("lmb") then changeDesc = false end
										end
									UiModalEnd()
								else
									UiButtonImageBox("ui/common/box-solid-4.png", 10, 10, 0.4, 0.4, 0.4)
								end

								local displayDesc = newDescChange
								if newDescChange == "" then displayDesc = "Enter Description" end
									
								if UiBlankButton(winW-gap*2-16, 120) and not changeDesc then
									changeDesc = not changeDesc
								end
								UiTranslate(7, 7)
								UiText(displayDesc)
							UiPop()

							UiTranslate(winW/2-gap, winH-92-gap*2)
							UiAlign("top center")
							UiPush()
								UiAlign("middle left")
								UiTranslate(gap+23-winW/2, -36)
								if disable then
									UiColorFilter(0.8, 0.8, 0.8, 0.75)
								end
								UiButtonImageBox("ui/common/score-frame-7.png", 12, 12)
								UiButtonHoverColor(1, 0.5, 0.2)
								UiButtonPressDist(0.2)
								UiButtonPressColor(0.9, 0.4, 0)
								UiPush()
									UiScale(0.6)
									if disable then
										UiBlankButton(45, 40)
									else
										if overwrite then
											UiColor(0.2, 1, 0.2)
											if UiImageButton("ui/hud/checkmark.png") then
												overwrite = not overwrite
											end
										else
											if UiBlankButton(45, 40) then
												overwrite = not overwrite
											end
										end
									end
								UiPop()
								UiTranslate(30, 0)
								UiColor(1, 1, 1)
								UiFont("regular.ttf", 22)
								UiText("Overwrite with current vehicle data")
							UiPop()
							UiPush()
								UiTranslate(-75, 0)
								UiButtonImageBox("ui/common/box-outline-fill-4.png", 10, 10)
								UiButtonHoverColor(1, 0.1, 0.1)
								UiFont("bold.ttf", 30)
								UiColor(1, 0.6, 0.2)
								if UiTextButton("Cancel", 100, 42) then
									editVehicle = false
									chnageName = false
									changeDesc = false
									overwrite = false
								end
							UiPop()
							UiPush()
								UiTranslate(75, 0)
								UiButtonImageBox("ui/common/box-outline-fill-4.png", 10, 10)
								UiFont("bold.ttf", 30)
								if newNameChange ~= "" then
									UiColor(0.3, 1, 0.3)
									UiButtonHoverColor(0.4, 1, 0.4)
									if UiTextButton("Save", 100, 42) then
										local savePosIndex = savedList[selectSaved].listPos
										if overwrite then
											SaveVehicleData(newNameChange, newDescChange, savePosIndex, choosenVehicle, selectionList, colorList)
											savedList[selectSaved].name = newNameChange
											savedList[selectSaved].desc = newDescChange
											savedList[selectSaved].model = choosenVehicle
										else
											SaveVehicleData(newNameChange, newDescChange, savePosIndex)
											savedList[selectSaved].name = newNameChange
											savedList[selectSaved].desc = newDescChange
										end
										editVehicle = false
										chnageName = false
										changeDesc = false
										overwrite = false
									end
								else
									UiColor(0.75, 0.75, 0.75)
									UiButtonHoverColor(1, 0.5, 0)
									UiTextButton("Save", 100, 42)
								end
							UiPop()
						UiPop()
					UiModalEnd()
				end
				if shortCodeStr ~= "" and shortCode and not freeCam and panelTranslate == 500 and showList then
					UiPush()
						UiAlign("middle center")
						UiColor(0, 0, 0, 0.55)
						UiFont("regular.ttf", 25)
						UiWordWrap(900)
						local wid, hig = UiGetTextSize(string.format("Short Code: %s", shortCodeStr))
						UiTranslate(UiCenter()-240, -hig/2)
						UiImageBox("ui/common/box-solid-4.png", wid+30, hig+20, 10, 10)
						UiColor(1, 1, 1)
						UiText(string.format("Short Code: %s", shortCodeStr))
					UiPop()
				end
			UiPop()
		end
	end
end




function DrawSlider(value, length, RGBs)
	RGBs = RGBs or {1, 1, 1}
	UiPush()
		UiAlign("left middle")
		UiColor(0.2, 0.2, 0.2, 0.6)
		UiRect(length+20, 20)
		UiColor(RGBs[1], RGBs[2], RGBs[3])
		slidValue, done = UiSlider("ui/common/box-solid-4.png", x, value, 0, length)
	UiPop()
	return slidValue, done
end


function DrawRGBselecter(RGBstr)
	local RGBs = HexToRGB(RGBstr) or {1, 1, 1}
	local Rt, rst, rstt = 0, false, false
	local Gt, gst, gstt = 0, false, false
	local Bt, gst, bstt = 0, false, false

	UiPush()
		UiAlign("middle center")
		UiFont("regular.ttf", 28)
		UiColor(0.9, 0.9, 0.9)
		UiButtonImageBox("ui/common/box-solid-4.png", 5, 5, 0.2, 0.2, 0.2, 0.5)
		UiPush()
			local Rorg = RGBs[1]*255
			local RorgDis = math.floor(Rorg)

			if changeR then
				UiColor(1, 0.6, 0.2)
				local lastPressed = InputLastPressedKey()
				local strLength = string.len(changeRstr)

				if tonumber(lastPressed) and strLength < 3 then

					changeRstr = changeRstr..lastPressed
					changeRstr = math.min(255, tonumber(changeRstr) or 0)
					RorgDis = changeRstr
					Rorg = tonumber(changeRstr)

				elseif lastPressed == "backspace" then

					changeRstr = string.sub(changeRstr, 1, strLength-1)
					changeRstr = math.min(255, tonumber(changeRstr) or 0)
					RorgDis = changeRstr
					Rorg = tonumber(changeRstr)

				elseif lastPressed == "delete" then

					changeRstr = 0
					RorgDis = changeRstr
					Rorg = tonumber(changeRstr)

				elseif lastPressed == "return" or lastPressed == "esc" then
					rstt = true
				end
			end

			if UiTextButton(RorgDis, 56, 32) and not changeG and not changeB then
				changeR = not changeR
				if changeR then
					changeRstr = RorgDis
				else
					rstt = true
				end
			end

			UiTranslate(45, 0)
			Rt, rst = DrawSlider(Rorg, 255, {1, 0, 0})
			if rst or rstt then changeR = false end
		UiPop()
		UiTranslate(0, 40)
		UiPush()
			local Gorg = RGBs[2]*255
			local GorgDis = math.floor(Gorg)

			if changeG then
				UiColor(1, 0.6, 0.2)
				local lastPressed = InputLastPressedKey()
				local strLength = string.len(changeGstr)

				if tonumber(lastPressed) and strLength < 3 then

					changeGstr = changeGstr..lastPressed
					changeGstr = math.min(255, tonumber(changeGstr) or 0)
					GorgDis = changeGstr
					Gorg = tonumber(changeGstr)

				elseif lastPressed == "backspace" then

					changeGstr = string.sub(changeGstr, 1, strLength-1)
					changeGstr = math.min(255, tonumber(changeGstr) or 0)
					GorgDis = changeGstr
					Gorg = tonumber(changeGstr)

				elseif lastPressed == "delete" then

					changeGstr = 0
					GorgDis = changeGstr
					Gorg = tonumber(changeGstr)

				elseif lastPressed == "return" or lastPressed == "esc" then
					gstt = true
				end
			end

			if UiTextButton(GorgDis, 56, 32) and not changeR and not changeB then
				changeG = not changeG
				if changeG then
					changeGstr = GorgDis
				else
					gstt = true
				end
			end

			UiTranslate(45, 0)
			Gt, gst = DrawSlider(Gorg, 255, {0, 1, 0})
			if gst or gstt then changeG = false end
		UiPop()
		UiTranslate(0, 40)
		UiPush()
			local Borg = RGBs[3]*255
			local BorgDis = math.floor(Borg)

			if changeB then
				UiColor(1, 0.6, 0.2)
				local lastPressed = InputLastPressedKey()
				local strLength = string.len(changeBstr)

				if tonumber(lastPressed) and strLength < 3 then

					changeBstr = changeBstr..lastPressed
					changeBstr = math.min(255, tonumber(changeBstr) or 0)
					BorgDis = changeBstr
					Borg = tonumber(changeBstr)

				elseif lastPressed == "backspace" then

					changeBstr = string.sub(changeBstr, 1, strLength-1)
					changeBstr = math.min(255, tonumber(changeBstr) or 0)
					BorgDis = changeBstr
					Borg = tonumber(changeBstr)

				elseif lastPressed == "delete" then

					changeBstr = 0
					BorgDis = changeBstr
					Borg = tonumber(changeBstr)

				elseif lastPressed == "return" or lastPressed == "esc" then
					bstt = true
				end
			end

			if UiTextButton(BorgDis, 56, 32) and not changeG and not changeR then
				changeB = not changeB
				if changeB then
					changeBstr = BorgDis
				else
					bstt = true
				end
			end

			UiTranslate(45, 0)
			Bt, bst = DrawSlider(Borg, 255, {0, 0, 1})
			if bst or bstt then changeB = false end
		UiPop()
	UiPop()

	return DecToHex(Rt)..DecToHex(Gt)..DecToHex(Bt), rst or gst or bst or rstt or gstt or bstt
end


function ResetRGB()
	changeR = false
	changeG = false
	changeB = false
	changeRstr = ""
	changeGstr = ""
	changeBstr = ""
end


function DecToHex(decNum, in255)
	if in255 == false then
		decNum = math.floor(decNum*255)
	end
	local hexString = "0123456789ABCDEF"
	local pos0, pos1 = (decNum%16)+1, math.floor(decNum/16)+1
	return string.sub(hexString, pos1, pos1)..string.sub(hexString, pos0, pos0)
end


function HexToDec(hexNum)
	local hexString = "0123456789ABCDEF"
	local pos1 = string.find(hexString, string.sub(hexNum, 1, 1))-1 or 0
	local pos0 = string.find(hexString, string.sub(hexNum, -1))-1 or 0
	return pos1*16+pos0
end


function UiHexColor(hexNum)
	local colorR = HexToDec(string.sub(hexNum, 1, 2))/255
	local colorG = HexToDec(string.sub(hexNum, 3, 4))/255
	local colorB = HexToDec(string.sub(hexNum, 5, 6))/255
	UiColor(colorR, colorG, colorB)
end


function HexToRGB(HEXcolor)
	return {HexToDec(string.sub(HEXcolor, 1, 2))/255, HexToDec(string.sub(HEXcolor, 3, 4))/255, HexToDec(string.sub(HEXcolor, 5, 6))/255}
end


function TypeinText(text, maxLength)
	local lastKey = InputLastPressedKey()
	local changeText = true
	local length = string.len(text)
	local inputReceived = false

	if lastKey ~= "" then
		inputReceived = true
		if string.len(lastKey) == 1 and length < maxLength then
			lastPressed = lastKey
			if InputDown("shift") then
				lastPressedText = lastKey
			else
				lastPressedText = string.lower(lastKey)
			end
			lastTime = GetTime()
		elseif lastKey == "space" and text ~= "" then
			lastPressed = "space"
			lastPressedText = " "
			lastTime = GetTime()
		elseif lastKey == "backspace" then
			inputReceived = false
			lastTime = GetTime()
			text = string.sub(text, 1, length-1)
			if InputDown("shift") then
				text = ""
			end
		elseif lastKey == "return" then
			inputReceived = false
			changeText = false
		else
			inputReceived = false
		end
	end

	if InputPressed(",") then
		inputReceived = true
		lastPressed = ","
		lastPressedText = ","
		lastTime = GetTime()
	end
	if InputPressed(".") then
		inputReceived = true
		lastPressed = "."
		lastPressedText = "."
		lastTime = GetTime()
	end
	
	if inputReceived and length < maxLength then
		text = text..lastPressedText
	end

	if InputDown(lastPressed) and (GetTime()-lastTime) > 0.4 and length < maxLength then
		text = text..lastPressedText
	end

	if InputDown("backspace") and (GetTime()-lastTime) > 0.4 then
		text = string.sub(text, 1, length-1)
	end

	return text, changeText
end


function DrawSubOptional(totalNum, groupList, list, disable)
	for t=1, totalNum do
		UiPush()
			if disable then
				UiColorFilter(0.8, 0.8, 0.8, 0.75)
			end
			if groupList[t+1].group then
				local posIndex = groupList[t+1].group
				if list[posIndex] == t+1 then
					UiButtonImageBox("ui/common/score-frame-7.png", 12, 12)
					UiButtonHoverColor(1, 0.5, 0.2)
					UiButtonPressDist(0.2)
					UiButtonPressColor(0.9, 0.4, 0)
					UiPush()
						UiScale(0.75)
						if UiImageButton("ui/hud/checkmark.png") and not disable then
							list[posIndex] = 0
						end
					UiPop()
				else
					UiButtonImageBox("ui/common/score-frame-7.png", 12, 12)
					UiButtonHoverColor(0.4, 1, 0.4)
					UiButtonPressDist(0.2)
					UiButtonPressColor(0.2, 0.9, 0.2)
					UiPush()
						UiScale(0.75)
						if UiBlankButton(45, 40) and not disable then
							list[posIndex] = t+1
						end
					UiPop()
				end
			else
				if list[t] then
					UiButtonImageBox("ui/common/score-frame-7.png", 12, 12)
					UiButtonHoverColor(1, 0.5, 0.2)
					UiButtonPressDist(0.2)
					UiButtonPressColor(0.9, 0.4, 0)
					UiPush()
						UiScale(0.75)
						if UiImageButton("ui/hud/checkmark.png") and not disable then
							list[t] = false
						end
					UiPop()
				else
					UiButtonImageBox("ui/common/score-frame-7.png", 12, 12)
					UiButtonHoverColor(0.4, 1, 0.4)
					UiButtonPressDist(0.2)
					UiButtonPressColor(0.2, 0.9, 0.2)
					UiPush()
						UiScale(0.75)
						if UiBlankButton(45, 40) and not disable then
							list[t] = true
						end
					UiPop()
				end
			end
			UiTranslate(40, 4)
			UiColor(1, 1, 1)
			UiFont("regular.ttf", 26)
			UiText(groupList[t+1].name)
		UiPop()
		UiTranslate(0, 45)
	end
	return list
end


function CheckSub(check, index, cond1, cond2, cond3)
	if check then
		for c=1, #check do
			if type(check[c]) == "number" then
				if check[c] < 0 then
					cond2 = true
					if selectionList[index] == math.abs(check[c]) then
						cond3 = true
					end
				else
					if selectionList[index] == check[c] then
						cond1 = false
						break
					end
				end
			elseif type(check[c]) == "string" then
				local checkStr = check[c]
				if string.sub(checkStr, 1, 1) == "=" then
					local checkListStr = table.concat(compChecklist, ", ")
					local realStr = string.sub(checkStr, 1-string.len(checkStr))
					if not string.match(checkListStr, realStr) then
						cond1 = false
						break
					end
				end
			end
		end
	end

	return cond1, cond2, cond3
end


function CheckCompatibilty(vehicleIndex, list1, list2, click)
	for g=1, 5 do
		local checkGroup = vehicles[vehicleIndex][3][g]
		for i=1, #checkGroup do
			local canSelect = true
			local blackListMain = checkGroup[i].blackList

			if blackListMain then
				local needReverseCheck = false
				local reverseCheck = false

				canSelect, needReverseCheck, reverseCheck = CheckSub(blackListMain.p1, 1, canSelect, needReverseCheck, reverseCheck)
				canSelect, needReverseCheck, reverseCheck = CheckSub(blackListMain.p2, 2, canSelect, needReverseCheck, reverseCheck)
				canSelect, needReverseCheck, reverseCheck = CheckSub(blackListMain.p3, 3, canSelect, needReverseCheck, reverseCheck)
				canSelect, needReverseCheck, reverseCheck = CheckSub(blackListMain.p4, 4, canSelect, needReverseCheck, reverseCheck)
				canSelect, needReverseCheck, reverseCheck = CheckSub(blackListMain.p5, 5, canSelect, needReverseCheck, reverseCheck)

				if canSelect and needReverseCheck then
					canSelect = reverseCheck
				end
			end

			if not canSelect then
				if g ~= 5 then
					if list1[g] == i then
						list1[g] = 0
					end
				else
					local content = list1[5]
					local exist = false
					local atPos = 0

					for c=1, #content do
						if content[c][1] == i then
							exist = true
							atPos = c
						end
					end

					if exist then
						table.remove(list1[5], atPos)
						table.remove(list2, atPos)
						click = 0
					end
				end
			end
		end
	end
	return list1, list2, click
end


function ReplaceBody(sourceStr, newBodyStr, targetStr)
	newBodyStr = newBodyStr or ""
	local protectCount = 0
	local replaceStr = "REPLACEBODY"..targetStr
	local endStr = "END"
	local newStr = sourceStr
	repeat
		local strLength = string.len(newStr)
		local startPos, endPos = string.find(newStr, replaceStr)
		endPos = endPos or strLength
		local beginPos, finalPos = string.find(newStr, endStr, endPos+1)
		if startPos and finalPos then
			newStr = string.sub(newStr, 1, startPos-1)..newBodyStr..string.sub(newStr, finalPos+3, strLength)
		end
		protectCount = protectCount + 1
	until( string.find(newStr, replaceStr) == nil or protectCount > 1000)
	return newStr
end


function RepaintVehicle(sourceStr, vehicleNum, paintNum, colorTable)
	local paintList = vehicles[vehicleNum][3][4][paintNum]
	local defaultList = vehicles[vehicleNum][3][4][1]
	local protectCount = 0
	local replaceStr = "REPLACEPAINT"
	local newStr = sourceStr
	repeat
		local startPos, endPos = string.find(newStr, replaceStr)
		local strLength = string.len(newStr)
		if startPos and endPos then
			local paintIndex = tonumber(string.sub(newStr, endPos+1, endPos+3))
			local paintStrList = (paintList.paintTable)[paintIndex]
			local defaultStrList = (defaultList.paintTable)[paintIndex]
			local paintListIndex = paintList.group or ""
			local defaultListIndex = defaultList.group or ""
			local paintStr = ""
			if paintStrList then
				for p=1, #paintStrList do
					local newLineStr = paintStrList[p]
					if not colorTable[p] then
						colorTable[p] = DecToHex(math.random(0, 255))..DecToHex(math.random(0, 255))..DecToHex(math.random(0, 255))
					end
					if newLineStr then
						local newLineStrLength = string.len(newLineStr)
						local colorString = table.concat(HexToRGB(colorTable[p]), " ")
						if newLineStr == "DEFAULT" then
							newLineStr = defaultStrList[1]
							newLineStrLength = string.len(newLineStr)
							if paintStr ~= "" then
								paintStr = paintStr.."\n"..string.sub(newLineStr, 1, newLineStrLength-3)..defaultListIndex.."-1"..'" color="'..colorString..string.sub(newLineStr, -3)
							else
								paintStr = string.sub(newLineStr, 1, newLineStrLength-3)..defaultListIndex.."-1"..'" color="'..colorString..string.sub(newLineStr, -3)
							end
						else
							if paintStr ~= "" then
								paintStr = paintStr.."\n"..string.sub(newLineStr, 1, newLineStrLength-3)..paintListIndex.."-"..p..'" color="'..colorString..string.sub(newLineStr, -3)
							else
								paintStr = string.sub(newLineStr, 1, newLineStrLength-3)..paintListIndex.."-"..p..'" color="'..colorString..string.sub(newLineStr, -3)
							end
						end
					end
				end
			end
			local tempStr = string.sub(newStr, 1, startPos-1)..paintStr..string.sub(newStr, endPos+3, strLength)
			newStr = tempStr
		end
		protectCount = protectCount + 1
	until( string.find(newStr, replaceStr) == nil or protectCount > 1000)
	return newStr
end


function ReplaceComponent(sourceStr, newCompStr, targetStr, compColor, isInstance)
	newCompStr = newCompStr or ""
	local protectCount = 0
	local replaceStr = "REPLACECOMP"..targetStr
	local endStr = "END"
	local newStr = sourceStr
	repeat
		local strLength = string.len(newStr)
		local startPos, endPos = string.find(newStr, replaceStr)
		endPos = endPos or strLength
		local beginPos, finalPos = string.find(newStr, endStr, endPos+1)
		if startPos and finalPos then
			if compColor then
				local strLeng = string.len(newCompStr)
				local colorString = table.concat(HexToRGB(compColor), " ")
				if isInstance then
					newCompStr = '<group prop0="color='..colorString..'">\n'..newCompStr.."\n</group>"
				else
					newCompStr = string.sub(newCompStr, 1, strLeng-2)..' color="'..colorString..'"'..string.sub(newCompStr, -2)
				end
			end
			newStr = string.sub(newStr, 1, startPos-1)..newCompStr..string.sub(newStr, finalPos+3, strLength)
		end
		protectCount = protectCount + 1
	until( string.find(newStr, replaceStr) == nil or protectCount > 1000)
	return newStr
end


function GetVehicleMainParam(vehicleNum, index)
	local paramString = '<vehicle tags="YLVF'
	local paramInitList = vehicles[vehicleNum][3][2][index].param
	local paramInitTag = vehicles[vehicleNum][3][2][index].tags
	local paramBodyTag = vehicles[vehicleNum][3][2][index].bodyTags
	local matchTable = {"sound", "spring", "damping", "topspeed", "acceleration", "strength", "antispin", "antiroll", "difflock", "steerassist", "friction"}
	if paramInitTag then
		paramString = paramString.." "..paramInitTag..'"'
	else
		paramString = paramString..'"'
	end
	for v=1, #paramInitList do
		if paramInitList[v] then
			paramString = paramString.." "..matchTable[v]..'="'..paramInitList[v]..'"'
		end
	end
	if paramBodyTag then
		paramBodyTag = " "..paramBodyTag
	else
		paramBodyTag = ""
	end
	paramString = paramString..'>\n<body pos="'..vehicles[vehicleNum][3][2][index].offset..'" tags="nocull'..paramBodyTag..'" dynamic="true">\n'
	return paramString
end


function ConstructVehicle(vehicleIndex, list, colorTable)
	local vehicleString = GetVehicleMainParam(vehicleIndex, list[2])
	local compList = list[5]
	local paint = list[4] or 1
	if list[1] then
		local num = list[1]
		vehicleString = vehicleString.."\n"..vehicles[vehicleIndex][3][1][num].xmlData
	end
	if list[2] then
		local num = list[2]
		vehicleString = vehicleString.."\n"..vehicles[vehicleIndex][3][2][num].xmlData
	end
	if list[3] and list[3] ~= 0 then
		local num = list[3]
		local compMain = vehicles[vehicleIndex][3][3][num]
		if compMain.replace then
			vehicleString = ReplaceBody(vehicleString, compMain.xmlData, compMain.replace)
		else
			vehicleString = vehicleString.."\n"..compMain.xmlData
		end
	end
	for i=1, #compList do
		local num = compList[i][1]
		local compMain = vehicles[vehicleIndex][3][5][num]
		local dataMain = compMain.xmlData
		local compType = type(dataMain)
		if compMain.replace then
			local targetStr = compMain.replace
			if compType == "string" then
				vehicleString = ReplaceComponent(vehicleString, dataMain, targetStr)
			elseif compType == "table" then
				for n=1, #dataMain do
					local compGroup = dataMain[n][1]
					local colorTableSub
					local isInstance = false
					if dataMain[1].canPaint then
						colorTableSub = colorTable[compList[i][3]]
						isInstance = dataMain[1].instance
					end
					if not dataMain[1].approx then
						targetString = targetStr.."_"..n
					else
						targetString = targetStr
					end
					if n == 1 then
						if compGroup then
							vehicleString = ReplaceComponent(vehicleString, compGroup, targetString, colorTableSub, isInstance)
						end
					else
						if dataMain[n].group then
							if compList[i][2][dataMain[n].group] == n then
								vehicleString = ReplaceComponent(vehicleString, compGroup, targetString, colorTableSub, isInstance)
							end
						else
							if compList[i][2][n-1] then
								vehicleString = ReplaceComponent(vehicleString, compGroup, targetString, colorTableSub, isInstance)
							end
						end
					end
				end
			end
		else
			if compType == "string" then
				vehicleString = vehicleString.."\n"..dataMain
			elseif compType == "table" then
				for n=1, #dataMain do
					if n == 1 then
						vehicleString = vehicleString.."\n"..dataMain[n][1]
					else
						if dataMain[n].group then
							if compList[i][2][dataMain[n].group] == n then
								vehicleString = vehicleString.."\n"..dataMain[n][1]
							end
						else
							if compList[i][2][n-1] then
								vehicleString = vehicleString.."\n"..dataMain[n][1]
							end
						end
					end
				end
			end
		end
	end
	vehicleString = RepaintVehicle(vehicleString, vehicleIndex, paint, colorTable)
	vehicleString = vehicleString.."\n</body>\n</vehicle>"
	return vehicleString
end


function SpawnVehicle(str)
	local pos = GetPlayerTransform().pos
	local rotPlayerX, rotPlayerY, rotPlayerZ = GetQuatEuler(GetPlayerTransform().rot)
	local rot = QuatEuler(0, rotPlayerY, 0)

	local spawnedList = Spawn(str, Transform(pos, rot))
	SetPlayerVehicle(spawnedList[1])
end


function PreviewVehicle(str, trans)
	if trans == {} or trans.pos == nil then
		local pos = GetPlayerTransform().pos
		local rotPlayerX, rotPlayerY, rotPlayerZ = GetQuatEuler(GetPlayerTransform().rot)
		local rot = QuatEuler(0, rotPlayerY, 0)
		trans = Transform(pos, rot)
	end

	local spawnedList = Spawn(str, trans)
	SetPlayerVehicle(spawnedList[1])
	return trans, spawnedList
end


function SaveVehicleData(name, desc, pos, vehicleModel, compData, colorData)
	local targetKey = "savegame.mod.vehicles."..pos
	local colorStr = ""

	SetString(targetKey..".name", name)
	SetString(targetKey..".desc", desc)
	ClearKey(targetKey..".comps")

	if vehicleModel then
		SetInt(targetKey..".model", vehicleModel)
	end

	if compData then
		SetString(targetKey..".main", compData[1].."/"..compData[2].."/"..compData[3].."/"..compData[4])
		if compData[5][1] then
			local tempList = selectionList[5]
			for i=1, #tempList do
				local subList = tempList[i]
				local subString = ""
				
				for j=1, #subList do
					local subContent = subList[j]

					if type(subContent) == "table" then
						local tableString = ""

						for k=1, #subContent do
							if type(subContent[k]) == "boolean" then
								if subContent[k] then
									if tableString == "" then
										tableString = "T"
									else
										tableString = tableString..",T"
									end
								else
									if tableString == "" then
										tableString = "F"
									else
										tableString = tableString..",F"
									end
								end
							else
								if tableString == "" then
									tableString = subContent[k]
								else
									tableString = tableString..","..subContent[k]
								end
							end
						end

						if subString == "" then
							subString = tableString
						else
							subString = subString.."/"..tableString
						end
					else
						if subString == "" then
							subString = subContent
						else
							subString = subString.."/"..subContent
						end
					end
				end
				SetString(targetKey..".comps."..i, subString)
			end
		end
	end

	if colorData then
		for c=1, #colorData do
			if colorStr ~= "" then
				colorStr = colorStr.."/"..colorData[c]
			else
				colorStr = colorData[c]
			end
		end
		SetString(targetKey..".color", colorStr)
	end
end


function LoadVehicleData(pos)
	local targetKey = "savegame.mod.vehicles."..pos
	local modelData = GetInt(targetKey..".model")
	local mainDataStr = GetString(targetKey..".main")
	local colorDataStr = GetString(targetKey..".color")
	local list1 = {1, 1, 0, 1, {}}
	local list2 = {}

	if modelData == 0 then modelData = 1 end

	if mainDataStr ~= "" then
		local prevPos = 1
		local dataCount = 0
		repeat
			dataCount = dataCount + 1
			local startPos, endPos = string.find(mainDataStr, "/", prevPos)
			if endPos == nil then endPos = 0 end
			list1[dataCount] = tonumber(string.sub(mainDataStr, prevPos, endPos-1)) or list1[dataCount]
			prevPos = endPos + 1
		until (startPos == nil or dataCount == 4)
	end

	if colorDataStr ~= "" then
		local prevPos = 1
		local dataCount = 0
		repeat
			dataCount = dataCount + 1
			local startPos, endPos = string.find(colorDataStr, "/", prevPos)
			if endPos == nil then endPos = 0 end
			list2[dataCount] = string.sub(colorDataStr, prevPos, endPos-1)
			prevPos = endPos + 1
		until (startPos == nil)
	end

	if HasKey(targetKey..".comps") then
		local compData = {}
		for i=1, #ListKeys(targetKey..".comps") do

			local compDataStr = GetString(targetKey..".comps."..i)
			local prevPos = 1

			local dataCount = 0
			compData[i] = {1, {}, 1}

			repeat
				dataCount = dataCount + 1
				local startPos, endPos = string.find(compDataStr, "/", prevPos)
				if endPos == nil then endPos = 0 end
				if dataCount == 2 then
					local subListStr = string.sub(compDataStr, prevPos, endPos-1)
					local prevSubPos = 1
					local subCount = 0
					repeat
						subCount = subCount + 1
						local subStartPos, subEndPos = string.find(subListStr, ",", prevSubPos)
						if subEndPos == nil then subEndPos = 0 end
						local str = string.sub(subListStr, prevSubPos, subEndPos-1)
						if tonumber(str) then
							compData[i][dataCount][subCount] = tonumber(str)
						else
							if str == "T" then
								compData[i][dataCount][subCount] = true
							elseif str == "F" then
								compData[i][dataCount][subCount] = false
							end
						end
						prevSubPos = subEndPos + 1
					until (subStartPos == nil)

				else
					compData[i][dataCount] = tonumber(string.sub(compDataStr, prevPos, endPos-1))
				end
				prevPos = endPos + 1
			until (startPos == nil)
		end
		rawset(list1, 5, compData)
	end

	return list1, list2, modelData
end


function GenerateCheckList(list1, vehicleIndex)
	local group = vehicles[vehicleIndex][3][5]
	local list2 = {}
	for i=1, #list1 do
		local listIndex = list1[i][1]
		list2[#list2+1] = group[listIndex].id
	end
	return list2
end


function GenerateShortCode(pos)
	local targetKey = "savegame.mod.vehicles."..pos
	local compNum = #ListKeys(targetKey..".comps")
	local mainDataStr = GetString(targetKey..".main")
	local list1 = {1, 1, 0, 1}

	local modelStr = string.format("%02d", math.max(1, GetInt(targetKey..".model")))
	local mainStr = ""

	if mainDataStr ~= "" then
		local prevPos = 1
		local dataCount = 0
		repeat
			dataCount = dataCount + 1
			local startPos, endPos = string.find(mainDataStr, "/", prevPos)
			if endPos == nil then endPos = 0 end
			local num = tonumber(string.sub(mainDataStr, prevPos, endPos-1)) or list1[dataCount]
			mainStr = string.format("%s%02d", mainStr, num)
			prevPos = endPos + 1
		until (startPos == nil or dataCount == 4)
	end

	local compStr = ""

	if compNum > 0 then
		for i=1, compNum do

			local compDataStr = GetString(targetKey..".comps."..i)
			local prevPos = 1
			local dataCount = 0

			repeat
				dataCount = dataCount + 1
				local startPos, endPos = string.find(compDataStr, "/", prevPos)
				if endPos == nil then endPos = 0 end
				if dataCount == 2 then
					compStr = string.format("%s:", compStr)
					local subListStr = string.sub(compDataStr, prevPos, endPos-1)
					local prevSubPos = 1
					local subCount = 0
					repeat
						subCount = subCount + 1
						local subStartPos, subEndPos = string.find(subListStr, ",", prevSubPos)
						if subEndPos == nil then subEndPos = 0 end
						local str = string.sub(subListStr, prevSubPos, subEndPos-1)
						if tonumber(str) then
							compStr = string.format("%s%02d", compStr, tonumber(str))
						else
							if str == "T" then
								compStr = string.format("%sb1", compStr)
							elseif str == "F" then
								compStr = string.format("%sb0", compStr)
							end
						end
						prevSubPos = subEndPos + 1
					until (subStartPos == nil)
					compStr = string.format("%s:", compStr)
				else
					local str = string.sub(compDataStr, prevPos, endPos-1)
					compStr = string.format("%s%02d", compStr, tonumber(str))
				end
				prevPos = endPos + 1
			until (startPos == nil)
			if i ~= compNum then
				compStr = string.format("%s/", compStr)
			end
		end
	end

	local colorStr = GetString(targetKey..".color")

	return string.format("%s%s;%s;%s", modelStr, mainStr, compStr, colorStr)
end
	
