
--[[
	------------------------------------------------
	| Hover Vehicle Pack                           |
	| 2022-07-16 (yyyy-mm-dd)                      |
	------------------------------------------------
]]

#include "YLVF/dataLib.lua"

vehicles = {}
paints = {}

-------------------------------------------------

PACKNAME = "Hover Vehicle Pack"
PACKAUTHOR = "YuLun"


NewVehicle("Valkyrie", "2 Doors 2 seats sporty pickup")

	str = '\
		<group pos="-0.05 -0.4 -0.1">\
			<compound pos="0.1 0.05 0.0" strength="4">\
				REPLACEPAINT01\
				<vox rot="0.0 -180.0 0.0" file="MOD/vox/pickup01_main.vox" object="body"/>\
				REPLACECOMP01END\
			</compound>\
			REPLACECOMPbcnTEND\
			<instance pos="-0.1 0.1 0.0" file="MOD/prefab/pickup01-const01.xml"/>\
			REPLACEBODY01<instance pos="0.1 1.55 0.6" file="MOD/prefab/pickup01-const02.xml"/>END\
			<body tags="Ydoor=driver nocull" pos="-0.8 0.25 -0.7" dynamic="true">\
				<compound pos="-0.2 0.0 0.0" strength="2.5">\
					REPLACECOMP02_2<vox pos="0.0 0.8 -0.4" rot="0.0 -180.0 0.0" file="MOD/vox/pickup01_main.vox" object="mirrorL"/>END\
					<vox pos="0.2 0.2 0.0" rot="0.0 -180.0 0.0" prop="false" file="MOD/vox/pickup01_main.vox" object="doorL"/>\
					REPLACEPAINT02\
				</compound>\
			</body>\
			<body tags="Ydoor nocull" pos="0.9 0.25 -0.7" dynamic="true">\
				<compound pos="0.1 0.0 0.0" strength="2.5">\
					REPLACECOMP02_3<vox pos="0.2 0.8 -0.4" rot="0.0 -180.0 0.0" file="MOD/vox/pickup01_main.vox" object="mirrorR"/>END\
					<vox pos="-0.1 0.2 0.0" rot="0.0 -180.0 0.0" prop="false" file="MOD/vox/pickup01_main.vox" object="doorR"/>\
					REPLACEPAINT03\
				</compound>\
			</body>\
			<body tags="Yhood nocull" pos="0.1 0.65 2.7" dynamic="true">\
				<compound pos="-0.1 0.0 0.1" strength="2.5">\
					<vox pos="0.0 0.5 0.0" file="MOD/vox/pickup01_main.vox" object="trunk"/>\
					REPLACEPAINT04\
				</compound>\
			</body>\
			<body tags="Yhood nocull" pos="0.0 0.95 -2.0" dynamic="true">\
				<compound pos="0.1 0.0 0.0" strength="2.5">\
					REPLACEPAINT05\
				</compound>\
				REPLACECOMP03_2END\
				REPLACECOMP03_3END\
			</body>\
		</group>'
	AddCabin("Standard 2 Doors", "Standard body with 2 seats and medium opened trunk", str)

	-- Cabin Ends --
	-- Chassis --

	str = '<instance pos="0.0 -0.75 -0.4" file="MOD/prefab/pickup01-chassis01.xml"/>'
	tableParam = {"pickup", 1, 0.9, 120, 2.4, 1.3, 0.1, 0.4, 0.9, 0.3, 1.8}
	AddChassis("Standard 4WD", "Standard 4WD with 1.7ES engine", str, tableParam, "0.0 0.65 0.0")

	str = '<instance pos="0.0 -0.75 -0.4" file="MOD/prefab/pickup01-chassis01.xml"/>'
	tableParam = {"pickup", 1, 0.9, 120, 2.6, 1.6, 0.1, 0.4, 0.9, 0.3, 1.8}
	AddChassis("Standard 4WD", "Standard 4WD with 2.1ES engine", str, tableParam, "0.0 0.65 0.0")

	-- Chassis Ends --
	-- Body --

	str = ' <compound pos="0.1 1.25 1.6" strength="4">\
				REPLACEPAINT06\
				REPLACECOMPtk_2<voxbox pos="-0.9 0.0 -1.1" size="17 5 4" brush="MOD/vox/pickup01_main.vox" object="cover1" color="1 1 1"/>END\
			</compound>\
			<body tags="Yhood" pos="0.1 1.25 2.6" dynamic="true">\
				<compound pos="-0.1 0.0 0.0" strength="7">\
					REPLACEPAINT07\
					REPLACECOMPtk_3END\
				</compound>\
				<instance pos="0.0 0.4 0.0" file="MOD/prefab/pickup01-const02.xml"/>\
				<joint pos="-0.5 0.55 -0.15" rot="0.0 -90.0 -90.0" type="hinge" size="0.15" limits="0 100"/>\
				<joint pos="0.4 0.55 -0.15" rot="0.0 -90.0 -90.0" type="hinge" size="0.15" limits="0 100"/>\
			</body>'
	AddBody("Trunk Cover", "cover_1", "Paintable metal trunk cover", str, nil, "01")

	-- Body Ends --
	-- Paint --

	tableParam = {
		{
			'<voxbox pos="-1.0 0.2 -2.8" size="19 14 56" brush="MOD/vox/pickup01_color.vox" object="body"/>'
		},
		{
			'<voxbox pos="0.1 0.0 -0.6" size="1 10 12" brush="MOD/vox/pickup01_color.vox" object="doorL"/>'
		},
		{
			'<voxbox pos="-0.1 0.0 -0.6" size="1 10 12" brush="MOD/vox/pickup01_color.vox" object="doorR"/>'
		},
		{
			'<voxbox pos="-0.7 0.0 -0.1" size="15 5 1" brush="MOD/vox/pickup01_color.vox" object="trunk"/>'
		},
		{
			'<voxbox pos="-0.9 0.0 -0.7" size="17 2 13" brush="MOD/vox/pickup01_color.vox" object="hood"/>'
		},
		{
			'<voxbox pos="-0.9 0.0 -1.0" size="17 6 22" brush="MOD/vox/pickup01_color.vox" object="cover"/>'
		},
		{
			'<voxbox pos="-0.7 0.0 -0.2" size="15 6 4" brush="MOD/vox/pickup01_color.vox" object="adtrunk"/>'
		}
	}
	AddPaint("Default Single Color", "Single color for entire vehicle", tableParam, 1, "1") -- 1

	tableParam = {
		{
			'DEFAULT',
			'<voxbox pos="-1.0 0.2 -0.9" size="19 9 37" brush="MOD/vox/pickup01_color.vox" object="body"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="0.1 0.0 -0.2" size="1 4 8" brush="MOD/vox/pickup01_color.vox" object="doorL"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.1 0.0 -0.2" size="1 4 8" brush="MOD/vox/pickup01_color.vox" object="doorR"/>'
		},
		{
			nil,
			'DEFAULT'
		},
		{
			'DEFAULT'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.9 0.0 -0.5" size="17 6 17" brush="MOD/vox/pickup01_color.vox" object="cover"/>'
		},
		{
			nil,
			'DEFAULT'
		}
	}
	AddPaint("Double Dash", "Two colors for entire vehicle, change color at middle of vehicle", tableParam, 2, "2")

	tableParam = {
		{
			'DEFAULT',
			'<voxbox pos="-1.0 0.2 -1.5" size="19 14 23" brush="MOD/vox/pickup01_color.vox" object="body"/>',
			'<voxbox pos="-1.0 0.2 -0.9" size="19 9 37" brush="MOD/vox/pickup01_color.vox" object="body"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="0.1 0.0 -0.6" size="1 8 12" brush="MOD/vox/pickup01_color.vox" object="doorL"/>',
			'<voxbox pos="0.1 0.0 -0.2" size="1 4 8" brush="MOD/vox/pickup01_color.vox" object="doorL"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.1 0.0 -0.6" size="1 8 12" brush="MOD/vox/pickup01_color.vox" object="doorR"/>',
			'<voxbox pos="-0.1 0.0 -0.2" size="1 4 8" brush="MOD/vox/pickup01_color.vox" object="doorR"/>'
		},
		{
			nil,
			nil,
			'DEFAULT'
		},
		{
			'DEFAULT'
		},
		{
			nil,
			'DEFAULT',
			'<voxbox pos="-0.9 0.0 -0.5" size="17 6 17" brush="MOD/vox/pickup01_color.vox" object="cover"/>'
		},
		{
			nil,
			nil,
			'DEFAULT'
		}
	}
	AddPaint("Triple Dash", "Three colors for entire vehicle, change color at middle of vehicle", tableParam, 3, "d2")

	tableParam = {
		{
			'DEFAULT',
			'<voxbox pos="-0.3 0.3 -2.8" size="5 13 56" brush="MOD/vox/pickup01_color.vox" object="body"/>'
		},
		{
			'DEFAULT'
		},
		{
			'DEFAULT'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.2 0.0 -0.1" size="5 5 1" brush="MOD/vox/pickup01_color.vox" object="trunk"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.3 0.0 -0.7" size="5 2 13" brush="MOD/vox/pickup01_color.vox" object="hood"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.3 0.4 -1.0" size="5 2 18" brush="MOD/vox/pickup01_color.vox" object="cover"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.2 0.0 -0.2" size="5 6 4" brush="MOD/vox/pickup01_color.vox" object="adtrunk"/>'
		}
	}
	AddPaint("Single Stripe (5 vox)", "One Color for entire vehicle with a colored stripe go through", tableParam, 2, "3")

	tableParam = {
		{
			'DEFAULT',
			'<voxbox pos="-0.5 0.2 -2.8" size="9 14 56" brush="MOD/vox/pickup01_color.vox" object="body"/>'
		},
		{
			'DEFAULT'
		},
		{
			'DEFAULT'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.4 0.0 -0.1" size="9 5 1" brush="MOD/vox/pickup01_color.vox" object="trunk"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.5 0.0 -0.7" size="9 2 13" brush="MOD/vox/pickup01_color.vox" object="hood"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.5 0.4 -1.0" size="9 2 18" brush="MOD/vox/pickup01_color.vox" object="cover"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.4 0.0 -0.2" size="9 6 4" brush="MOD/vox/pickup01_color.vox" object="adtrunk"/>'
		}
	}
	AddPaint("Single Stripe (9 vox)", "One Color for entire vehicle with a colored stripe go through", tableParam, 2, "4") -- 5

	tableParam = {
		{
			'DEFAULT',
			'<voxbox pos="-0.5 0.2 -2.8" size="9 14 56" brush="MOD/vox/pickup01_color.vox" object="body"/>'
		},
		{
			'DEFAULT'
		},
		{
			'DEFAULT'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.4 0.0 -0.1" size="9 5 1" brush="MOD/vox/pickup01_color.vox" object="trunk"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.5 0.0 -0.7" size="9 2 13" brush="MOD/vox/pickup01_color.vox" object="hood"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.5 0.4 -1.0" size="9 2 18" brush="MOD/vox/pickup01_color.vox" object="cover"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.4 0.0 -0.2" size="9 6 4" brush="MOD/vox/pickup01_color.vox" object="adtrunk"/>'
		}
	}
	AddPaint("Double Stripes (3+3+3 vox)", "One Color for entire vehicle with two colored stripes go through", tableParam, 2, "5")

	tableParam = {
		{
			'DEFAULT',
			'<voxbox pos="-1.0 0.3 -2.7" size="19 9 55" brush="MOD/vox/pickup01_color.vox" object="body"/>',
			'<voxbox pos="-1.0 0.2 -0.2" size="19 1 1" brush="MOD/vox/pickup01_color.vox" object="body"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="0.1 0.1 -0.5" size="1 9 10" brush="MOD/vox/pickup01_color.vox" object="doorL"/>',
			'<voxbox pos="0.1 0.0 -0.6" size="1 9 12" brush="MOD/vox/pickup01_color.vox" object="doorL"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.1 0.1 -0.5" size="1 9 10" brush="MOD/vox/pickup01_color.vox" object="doorR"/>',
			'<voxbox pos="-0.1 0.0 -0.6" size="1 9 12" brush="MOD/vox/pickup01_color.vox" object="doorR"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.6 0.1 -0.1" size="13 4 1" brush="MOD/vox/pickup01_color.vox" object="trunk"/>',
			'<voxbox pos="-0.7 0.0 -0.1" size="15 5 1" brush="MOD/vox/pickup01_color.vox" object="trunk"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.9 0.0 -0.7" size="17 2 13" brush="MOD/vox/pickup01_color.vox" object="hood"/>'
		},
		{
			'DEFAULT'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.6 0.0 -0.1" size="13 4 3" brush="MOD/vox/pickup01_color.vox" object="adtrunk"/>',
			'<voxbox pos="-0.7 0.0 -0.1" size="15 6 3" brush="MOD/vox/pickup01_color.vox" object="adtrunk"/>'
		}
	}
	AddPaint("Working Stripes (2+2 vox)", "Two alternating stripes with some outline, last 2 color slots for beacons", tableParam, 5, "ws1")

	tableParam = {
		{
			'DEFAULT',
			'<voxbox pos="-1.0 0.6 -2.8" size="19 10 56" brush="MOD/vox/pickup01_color.vox" object="body"/>',
			'<voxbox pos="-1.0 1.1 -1.2" size="19 5 20" brush="MOD/vox/pickup01_color.vox" object="body"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="0.1 0.4 -0.6" size="1 5 12" brush="MOD/vox/pickup01_color.vox" object="doorL"/>',
			'<voxbox pos="0.1 0.9 -0.5" size="1 1 1" brush="MOD/vox/pickup01_color.vox" object="doorL"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.1 0.4 -0.6" size="1 5 12" brush="MOD/vox/pickup01_color.vox" object="doorR"/>',
			'<voxbox pos="-0.1 0.9 -0.5" size="1 1 1" brush="MOD/vox/pickup01_color.vox" object="doorR"/>'
		},
		{
			nil,
			'DEFAULT'
		},
		{
			nil,
			'DEFAULT',
			'<voxbox pos="-0.3 0.0 -0.6" size="5 2 12" brush="MOD/vox/pickup01_color.vox" object="hood"/>'
		},
		{
			nil,
			'DEFAULT',
			'<voxbox pos="-0.9 0.0 -1.0" size="17 6 22" brush="MOD/vox/pickup01_color.vox" object="cover"/>'
		},
		{
			nil,
			'DEFAULT',
			'<voxbox pos="-0.7 0.0 -0.2" size="15 5 4" brush="MOD/vox/pickup01_color.vox" object="adtrunk"/>'
		}
	}
	AddPaint("Emergency 1", "Emergency paint layout 1, last 2 color slots for beacons", tableParam, 5, "p1")

	tableParam = {
		{
			'DEFAULT',
			'<voxbox pos="-1.0 0.2 -2.8" size="19 10 56" brush="MOD/vox/pickup01_color.vox" object="body"/>',
			'<voxbox pos="-0.8 1.5 -0.7" size="15 1 12" brush="MOD/vox/pickup01_color.vox" object="body"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="0.1 0.0 -0.6" size="1 10 12" brush="MOD/vox/pickup01_color.vox" object="doorL"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.1 0.0 -0.6" size="1 10 12" brush="MOD/vox/pickup01_color.vox" object="doorR"/>'
		},
		{
			'DEFAULT',
			'<voxbox pos="-0.7 0.3 -0.1" size="15 2 1" brush="MOD/vox/pickup01_color.vox" object="trunk"/>'
		},
		{
			'DEFAULT',
			nil,
			'<voxbox pos="-0.8 0.0 -0.7" size="15 2 13" brush="MOD/vox/pickup01_color.vox" object="hood"/>'
		},
		{
			'DEFAULT',
			nil,
			'<voxbox pos="-0.9 0.3 -1.0" size="17 3 20" brush="MOD/vox/pickup01_color.vox" object="cover"/>'
		},
		{
			'DEFAULT',
			nil,
			'<voxbox pos="-0.7 0.3 -0.2" size="15 3 3" brush="MOD/vox/pickup01_color.vox" object="adtrunk"/>'
		}
	}
	AddPaint("Emergency 2", "Emergency paint layout 2, last 2 color slots for beacons", tableParam, 5, "p2")

	-- Paint Ends --
	-- Component --

	tableParam = {
		{'<instance pos="0.0 1.2 -0.2" file="MOD/prefab/pickup01-roof_rack01.xml"/>'},
		{'<instance pos="0.0 1.4 -0.82" file="MOD/prefab/light-black_2x2-6.xml"/>', name = "6 Single lights", group = 1},
		{'<instance pos="0.0 1.4 -0.82" file="MOD/prefab/light-black_14x2.xml"/>', name = "Light bar (14 vox)", group = 1},
		{'<instance pos="0.0 1.4 -0.82" file="MOD/prefab/light-black_16x2.xml"/>', name = "Light bar (16 vox)", group = 1}
	}
	AddComponent("Roof Rack 1", "roofr_1", "Black roof rack with optional lights", tableParam, {p5 = {"roofr", "bcnT"}})

	str = '<instance pos="0.0 1.2 -0.1" file="MOD/prefab/pickup01-roof_rack_light01.xml"/>'
	AddComponent("Roof Rack 2", "roofr_2", "Black roof rack with additional lights", str, {p3 = {1}, p5 = {"roofr", "bcnT"}})

	tableParam = {
		{'<instance pos="0.0 1.2 -0.2" file="MOD/prefab/pickup01-roof_rack02.xml"/>'},
		{'<instance pos="0.0 1.4 -0.82" file="MOD/prefab/light-black_2x2-6.xml"/>', name = "6 Single lights", group = 1},
		{'<instance pos="0.0 1.4 -0.82" file="MOD/prefab/light-black_2x2-7.xml"/>', name = "7 Single lights", group = 1},
		{'<instance pos="0.0 1.4 -0.82" file="MOD/prefab/light-black_14x2.xml"/>', name = "Light bar (14 vox)", group = 1},
		{'<instance pos="0.0 1.4 -0.82" file="MOD/prefab/light-black_16x2.xml"/>', name = "Light bar (16 vox)", group = 1}
	}
	AddComponent("Roof Rack 3", "roofr_3", "Long black roof rack extends to trunk with optional lights", tableParam, {p3 = {1}, p5 = {"roofr", "bcnT"}})

	tableParam = {
		{'<instance pos="0.0 1.2 -0.2" file="MOD/prefab/pickup01-roof_rack03.xml"/>'},
		{'<instance pos="0.0 1.4 -0.82" file="MOD/prefab/light-black_2x2-6.xml"/>', name = "6 Single lights", group = 1},
		{'<instance pos="0.0 1.4 -0.82" file="MOD/prefab/light-black_2x2-7.xml"/>', name = "7 Single lights", group = 1},
		{'<instance pos="0.0 1.4 -0.82" file="MOD/prefab/light-black_14x2.xml"/>', name = "Light bar (14 vox)", group = 1},
		{'<instance pos="0.0 1.4 -0.82" file="MOD/prefab/light-black_16x2.xml"/>', name = "Light bar (16 vox)", group = 1}
	}
	AddComponent("Roof Rack 4", "roofr_4", "Black roof rack with trunk fence and optional lights", tableParam, {p3 = {1}, p5 = {"roofr", "bcnT"}})

	tableParam = {
		{},
		{'<voxbox pos="-0.9 0.0 -1.1" size="17 5 20" brush="MOD/vox/pickup01_main.vox" object="cover1" color="1 1 1"/>', name = "Sides"},
		{'<voxbox pos="-0.6 0.0 -0.2" size="13 5 4" brush="MOD/vox/pickup01_main.vox" object="adtrunk" color="1 1 1"/>', name = "Rear"}
	}
	AddComponent("Windowed Trunk Cover", "", "Replace fully closed cover to windowed", tableParam, {p3 = {-1}}, "tk")

	tableParam = {
		{approx = true},
		{
			'<group pos="0.0 1.6 -0.2" prop0="strength=4">\
			REPLACECOMPbcnPT_2<instance pos="0.0 0.0 0.0" file="MOD/prefab/beacon-base01_6x4-2+3.xml"/>END\
			REPLACECOMPbcnRPa_2<instance pos="-0.4 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type01a.xml"/>END\
			REPLACECOMPbcnRPb_2<instance pos="0.5 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type01b.xml"/>END\
			</group>',
			name = "Light bar, type 1A", group = 1
		},
		{
			'<group pos="0.0 1.6 -0.2" prop0="strength=4">\
			REPLACECOMPbcnPT_2<instance pos="0.0 0.0 0.0" file="MOD/prefab/beacon-base01_6x4-2+3.xml"/>END\
			REPLACECOMPbcnRPa_3<instance pos="-0.4 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type02a.xml"/>END\
			REPLACECOMPbcnRPb_3<instance pos="0.5 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type02b.xml"/>END\
			</group>',
			name = "Light bar, type 1B", group = 1
		},
		{
			'<group pos="0.0 1.6 -0.2" prop0="strength=4">\
			REPLACECOMPbcnPT_2<instance pos="0.0 0.0 0.0" file="MOD/prefab/beacon-base01_6x4-2+3.xml"/>END\
			REPLACECOMPbcnRPa_4<instance pos="-0.4 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type03a.xml"/>END\
			REPLACECOMPbcnRPb_4<instance pos="0.5 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type03b.xml"/>END\
			</group>',
			name = "Light bar, type 1C", group = 1
		},
		{
			'<group pos="0.0 1.6 -0.2" prop0="strength=4">\
			REPLACECOMPbcnPT_2<instance pos="0.0 0.0 0.0" file="MOD/prefab/beacon-base01_6x4-2+3.xml"/>END\
			REPLACECOMPbcnRPa_5<instance pos="-0.4 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type04a.xml"/>END\
			REPLACECOMPbcnRPb_5<instance pos="0.5 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type04b.xml"/>END\
			</group>',
			name = "Light bar, type 1D", group = 1
		},
		{
			'<group pos="0.0 1.6 -0.2" prop0="strength=4">\
			REPLACECOMPbcnPT_2<instance pos="0.0 0.0 0.0" file="MOD/prefab/beacon-base01_6x4-2+3.xml"/>END\
			REPLACECOMPbcnRPa_5<instance pos="-0.4 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type05a.xml"/>END\
			REPLACECOMPbcnRPb_5<instance pos="0.5 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type05b.xml"/>END\
			</group>',
			name = "Light bar, type 1E", group = 1
		}
	}
	AddComponent("Rooftop Beacons", "bcnT_base", "Add a rooftop beacon light bar, default white light", tableParam, {p4 = {-7, -8, -9}, p5 = {"roofr"}}, "bcnT")

	tableParam = {
		{noOption = true},
		{'<instance pos="0.0 0.0 0.0" file="MOD/prefab/beacon-base01b_6x4-2+3.xml"/>'}
	}
	AddComponent("Black beacons", "", "Paint all beacons frame & body to black", tableParam, {p4 = {-7, -8, -9}, p5 = {"=bcnT_base"}}, "bcnPT")

	tableParam = {
		{instance = true, canPaint = true, noOption = true},
		{'<instance pos="-0.4 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type01a.xml"/>'},
		{'<instance pos="-0.4 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type02a.xml"/>'},
		{'<instance pos="-0.4 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type03a.xml"/>'},
		{'<instance pos="-0.4 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type04a.xml"/>'},
		{'<instance pos="-0.4 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type05a.xml"/>'}
	}
	AddComponent("Beacon Color A", "", "Change one color used by beacon", tableParam, {p4 = {-7, -8, -9}, p5 = {"=bcnT_base"}}, "bcnRPa")

	tableParam = {
		{instance = true, canPaint = true, noOption = true},
		{'<instance pos="0.5 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type01b.xml"/>'},
		{'<instance pos="0.5 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type02b.xml"/>'},
		{'<instance pos="0.5 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type03b.xml"/>'},
		{'<instance pos="0.5 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type04b.xml"/>'},
		{'<instance pos="0.5 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type05b.xml"/>'}
	}
	AddComponent("Beacon Color B", "", "Change one color used by beacon", tableParam, {p4 = {-7, -8, -9}, p5 = {"=bcnT_base"}}, "bcnRPb")

	tableParam = {
		{'<instance pos="0.0 -0.3 -2.9" file="MOD/prefab/pickup01-front_bumper01.xml"/>'},
		{'<instance pos="0.0 -0.1 -3.0" file="MOD/prefab/winch01.xml"/>', name = "Winch", group = 1},
		{'<instance pos="0.0 0.4 -3.08" file="MOD/prefab/light-black_8x2.xml"/>', name = "Light bar (8 vox)", group = 2},
		{'<instance pos="0.0 0.46 -3.01" file="MOD/prefab/light-black_2x2-4.xml"/>', name = "4 Single lights", group = 2}
	}
	AddComponent("Front Bumper 1", "fbumper_1", "Black front bumper with optional parts", tableParam, {p5 = {"fbumper"}})

	str = '<vox pos="0.7 1.1 -1.2" rot="0.0 -180.0 0.0" file="MOD/vox/pickup01_ext-parts.vox" object="intake1"/>'
	AddComponent("Air Intake 1", "intake-1", "Black metal air intake", str, {p5 = {"intake"}}, "01")

	tableParam = {
		{noOption = true, canPaint = true},
		{'<voxbox pos="-0.2 0.8 -0.5" size="3 2 2" brush="MOD/vox/pickup01_main.vox" object="mirrorRp"/>'},
		{'<voxbox pos="0.0 0.8 -0.4" size="3 2 2" brush="MOD/vox/pickup01_main.vox" object="mirrorLp"/>'}
	}
	AddComponent("Painted Mirrors", "nmirr_1", "Replace default black mirrors to painted", tableParam, {p5 = {"nmirr"}}, "02")

	tableParam = {
		{noOption = true},
		{'<vox pos="0.0 0.8 -0.4" rot="0.0 -180.0 0.0" file="MOD/vox/pickup01_main.vox" object="mirrorLch"/>'},
		{'<vox pos="0.2 0.8 -0.4" rot="0.0 -180.0 0.0" file="MOD/vox/pickup01_main.vox" object="mirrorRch"/>'}
	}
	AddComponent("Chromed Mirrors", "nmirr_2", "Replace default black mirrors to chromed", tableParam, {p5 = {"nmirr"}}, "02")

	tableParam = {
		{canPaint = true},
		{'<voxbox pos="-0.9 0.1 -0.5" size="2 3 2" brush="MOD/vox/pickup01_main.vox" object="admirrorRp"/>', name = "Left"},
		{'<voxbox pos="0.8 0.1 -0.5" size="2 3 2" brush="MOD/vox/pickup01_main.vox" object="admirrorLp"/>', name = "Right"}
	}
	AddComponent("Painted Additional Mirrors", "admirr_1", "Add painted additional mirrors", tableParam, {p5 = {"admirr"}}, "03")

	tableParam = {
		{},
		{'<vox pos="-0.8 0.1 -0.4" rot="0.0 -180.0 0.0" file="MOD/vox/pickup01_main.vox" object="admirrorLch"/>', name = "Left"},
		{'<vox pos="0.9 0.1 -0.4" rot="0.0 -180.0 0.0" file="MOD/vox/pickup01_main.vox" object="admirrorRch"/>', name = "Right"}
	}
	AddComponent("Chromed Additional Mirrors", "admirr_2", "Add chromed additional mirrors", tableParam, {p5 = {"admirr"}}, "03")

	tableParam = {
		{},
		{'<vox pos="-0.8 0.1 -0.4" rot="0.0 -180.0 0.0" file="MOD/vox/pickup01_main.vox" object="admirrorL"/>', name = "Left"},
		{'<vox pos="0.9 0.1 -0.4" rot="0.0 -180.0 0.0" file="MOD/vox/pickup01_main.vox" object="admirrorR"/>', name = "Right"}
	}
	AddComponent("Black Additional Mirrors", "admirr_3", "Add black additional mirrors", tableParam, {p5 = {"admirr"}}, "03")
	

FinishVehicle()

NewVehicle("Entrory", "4 doors 5 seats sporty jeep")

	str = '\
		<group pos="-0.2 -0.8 0.3">\
			<compound pos="0.25 0.4 0.0" strength="4">\
				<vox pos="0.0 0.0 -0.1" rot="0.0 -180.0 0.0" file="MOD/vox/jeep01_main.vox" object="body"/>\
				REPLACEPAINT01\
				REPLACECOMP01END\
				REPLACECOMP03_2END\
				REPLACECOMP03_3END\
			</compound>\
			REPLACECOMPbcnTEND\
			<instance pos="0.0 0.5 -0.1" file="MOD/prefab/jeep01-const01.xml"/>\
			<body tags="Ydoor=driver nocull" pos="-0.65 0.6 -0.9" dynamic="true">\
				<compound pos="-0.1 0.0 0.1" strength="2.5">\
					<vox pos="0.1 0.2 0.0" rot="0.0 -180.0 0.0" file="MOD/vox/jeep01_main.vox" object="doorL"/>\
					REPLACECOMP02_2<vox pos="-0.1 0.9 -0.4" rot="0.0 -180.0 0.0" file="MOD/vox/pickup01_main.vox" object="mirrorL"/>END\
					REPLACEPAINT02\
				</compound>\
			</body>\
			<body tags="Ydoor nocull" pos="1.05 0.6 -0.9" dynamic="true">\
				<compound pos="0.2 0.0 0.1" strength="2.5">\
					<vox pos="-0.2 0.2 0.0" rot="0.0 -180.0 0.0" file="MOD/vox/jeep01_main.vox" object="doorR"/>\
					REPLACECOMP02_3<vox pos="0.1 0.9 -0.4" rot="0.0 -180.0 0.0" file="MOD/vox/pickup01_main.vox" object="mirrorR"/>END\
					REPLACEPAINT03\
				</compound>\
			</body>\
			<body tags="Ydoor nocull" pos="-0.65 0.6 0.3" dynamic="true">\
				<compound pos="0.0 0.0 0.1" strength="2.5">\
					<vox pos="0.0 0.2 -0.1" rot="0.0 -180.0 0.0" file="MOD/vox/jeep01_main.vox" object="doorLm"/>\
					REPLACEPAINT04\
				</compound>\
			</body>\
			<body tags="Ydoor nocull" pos="1.05 0.6 0.3" dynamic="true">\
				<compound pos="0.0 0.0 0.1" strength="2.5">\
					<vox pos="0.0 0.2 -0.1" rot="0.0 -180.0 0.0" file="MOD/vox/jeep01_main.vox" object="doorRm"/>\
					REPLACEPAINT05\
				</compound>\
			</body>\
			<body tags="Yhood nocull" pos="0.25 0.9 2.5" dynamic="true">\
				<compound pos="0.0 0.0 0.0" strength="2.5">\
					<vox pos="0.0 0.1 0.0" rot="0.0 -180.0 0.0" file="MOD/vox/jeep01_main.vox" object="backdoor"/>\
					REPLACEPAINT06\
				</compound>\
				<instance pos="0.0 1.1 0.0" file="MOD/prefab/pickup01-const02.xml"/>\
			</body>\
			<body tags="Yhood nocull" pos="0.25 1.4 -2.2" dynamic="true">\
				<compound pos="0.0 0.0 0.1" strength="2.5">\
					REPLACEPAINT07\
				</compound>\
			</body>\
		</group>'
	
	AddCabin("Standard 4 doors", "Standard: 4 doors, 5 seats and trunk space", str)

	-- Cabin Ends --
	-- Chassis --

	str = '<instance pos="0.0 -0.8 -0.1" file="MOD/prefab/pickup01-chassis01.xml"/>'
	tableParam = {"pickup", 1.1, 0.8, 120, 2.4, 1.7, 0.1, 0.45, 0.9, 0.3, 1.8}
	AddChassis("Standard 4WD", "Standard 4WD with 2.2EP V8 engine", str, tableParam, "-0.05 0.7 -0.2")

	str = '<instance pos="0.0 -0.8 -0.1" file="MOD/prefab/pickup01-chassis01.xml"/>'
	tableParam = {"pickup", 1.1, 0.8, 120, 2.6, 2.4, 0.1, 0.45, 0.9, 0.3, 1.8}
	AddChassis("Standard 4WD", "Standard 4WD with 2.7EP V8 engine", str, tableParam, "-0.05 0.7 -0.2")

	-- Chassis Ends --
	-- Body --

	-- Body Ends --
	-- Paint --

	tableParam = {
		{
			'<voxbox pos="-1.0 0.2 -2.9" size="19 16 57" brush="MOD/vox/jeep01_color.vox" object="body"/>'
		},
		{ -- FL
			'<voxbox pos="0.0 0.0 -0.6" size="1 9 11" brush="MOD/vox/jeep01_color.vox" object="doorA"/>'
		},
		{ -- FR
			'<voxbox pos="-0.2 0.0 -0.6" size="1 9 11" brush="MOD/vox/jeep01_color.vox" object="doorA"/>'
		},
		{ -- RL
			'<voxbox pos="-0.1 0.0 -0.6" size="1 9 11" brush="MOD/vox/jeep01_color.vox" object="doorB"/>'
		},
		{ -- RR
			'<voxbox pos="0.0 0.0 -0.6" size="1 9 11" brush="MOD/vox/jeep01_color.vox" object="doorB"/>'
		},
		{
			'<voxbox pos="-0.9 0.0 -0.2" size="17 13 4" brush="MOD/vox/jeep01_color.vox" object="rearDoor"/>'
		},
		{
			'<voxbox pos="-0.9 0.0 -0.7" size="17 2 13" brush="MOD/vox/jeep01_color.vox" object="hood"/>'
		}
	}
	AddPaint("Default Single Color", "Single color for entire vehicle", tableParam, 1, "0") -- 1

	tableParam = {
		{
			"DEFAULT",
			'<voxbox pos="-0.3 0.3 -2.9" size="5 15 57" brush="MOD/vox/jeep01_color.vox" object="body"/>'
		},
		{ -- FL
			"DEFAULT"
		},
		{ -- FR
			"DEFAULT"
		},
		{ -- RL
			"DEFAULT"
		},
		{ -- RR
			"DEFAULT"
		},
		{
			"DEFAULT",
			'<voxbox pos="-0.3 0.0 -0.2" size="5 13 4" brush="MOD/vox/jeep01_color.vox" object="rearDoor"/>'
		},
		{
			"DEFAULT",
			'<voxbox pos="-0.3 0.0 -0.7" size="5 2 12" brush="MOD/vox/jeep01_color.vox" object="hood"/>'
		}
	}
	AddPaint("Single Stripe (5 vox)", "One Color for entire vehicle with a colored stripe", tableParam, 2, "stp1")

	tableParam = {
		{
			"DEFAULT",
			'<voxbox pos="-0.4 0.3 -2.9" size="7 15 57" brush="MOD/vox/jeep01_color.vox" object="body"/>'
		},
		{ -- FL
			"DEFAULT"
		},
		{ -- FR
			"DEFAULT"
		},
		{ -- RL
			"DEFAULT"
		},
		{ -- RR
			"DEFAULT"
		},
		{
			"DEFAULT",
			'<voxbox pos="-0.4 0.0 -0.2" size="7 13 4" brush="MOD/vox/jeep01_color.vox" object="rearDoor"/>'
		},
		{
			"DEFAULT",
			'<voxbox pos="-0.4 0.0 -0.7" size="7 2 12" brush="MOD/vox/jeep01_color.vox" object="hood"/>'
		}
	}
	AddPaint("Single Stripe (7 vox)", "One Color for entire vehicle with a colored stripe", tableParam, 2, "stp2")

	tableParam = {
		{
			"DEFAULT",
			'<voxbox pos="-0.5 0.3 -2.9" size="9 15 57" brush="MOD/vox/jeep01_color.vox" object="body"/>'
		},
		{ -- FL
			"DEFAULT"
		},
		{ -- FR
			"DEFAULT"
		},
		{ -- RL
			"DEFAULT"
		},
		{ -- RR
			"DEFAULT"
		},
		{
			"DEFAULT",
			'<voxbox pos="-0.5 0.0 -0.2" size="9 13 4" brush="MOD/vox/jeep01_color.vox" object="rearDoor"/>'
		},
		{
			"DEFAULT",
			'<voxbox pos="-0.5 0.0 -0.7" size="9 2 12" brush="MOD/vox/jeep01_color.vox" object="hood"/>'
		}
	}
	AddPaint("Double Stripe (3+3+3 vox)", "One Color for entire vehicle with two colored stripes", tableParam, 2, "stp3")

	tableParam = {
		{
			"DEFAULT",
			'<voxbox pos="-1.0 0.5 -0.3" size="19 5 27" brush="MOD/vox/jeep01_color.vox" object="body"/>'
		},
		{ -- FL
			"DEFAULT",
			'<voxbox pos="0.0 0.0 -0.6" size="1 8 11" brush="MOD/vox/jeep01_color.vox" object="doorA"/>'
		},
		{ -- FR
			"DEFAULT",
			'<voxbox pos="-0.2 0.0 -0.6" size="1 8 11" brush="MOD/vox/jeep01_color.vox" object="doorA"/>'
		},
		{ -- RL
			"DEFAULT",
			'<voxbox pos="-0.1 0.0 -0.6" size="1 8 11" brush="MOD/vox/jeep01_color.vox" object="doorB"/>'
		},
		{ -- RR
			"DEFAULT",
			'<voxbox pos="0.0 0.0 -0.6" size="1 8 11" brush="MOD/vox/jeep01_color.vox" object="doorB"/>'
		},
		{
			"DEFAULT"
		},
		{
			"DEFAULT"
		}
	}
	AddPaint("Flow", "Patten on sides of vehicle", tableParam, 2, "flw") -- 5

	tableParam = {
		{
			"DEFAULT",
			'<voxbox pos="-1.0 0.2 -2.9" size="19 4 57" brush="MOD/vox/jeep01_color.vox" object="body"/>',
			'<voxbox pos="-1.0 1.1 -1.4" size="19 7 39" brush="MOD/vox/jeep01_color.vox" object="body"/>'
		},
		{ -- FL
			"DEFAULT",
			'<voxbox pos="0.0 0.0 -0.6" size="1 4 11" brush="MOD/vox/jeep01_color.vox" object="doorA"/>'
		},
		{ -- FR
			"DEFAULT",
			'<voxbox pos="-0.2 0.0 -0.6" size="1 4 11" brush="MOD/vox/jeep01_color.vox" object="doorA"/>'
		},
		{ -- RL
			"DEFAULT",
			'<voxbox pos="-0.1 0.0 -0.6" size="1 4 9" brush="MOD/vox/jeep01_color.vox" object="doorB"/>'
		},
		{ -- RR
			"DEFAULT",
			'<voxbox pos="0.0 0.0 -0.6" size="1 4 9" brush="MOD/vox/jeep01_color.vox" object="doorB"/>'
		},
		{
			"DEFAULT",
			'<voxbox pos="-0.9 0.6 -0.2" size="17 1 2" brush="MOD/vox/jeep01_color.vox" object="rearDoor"/>'
		},
		{
			"DEFAULT",
			nil,
			'<voxbox pos="-0.3 0.0 -0.6" size="5 2 11" brush="MOD/vox/jeep01_color.vox" object="hood"/>'
		}
	}
	AddPaint("Emergency 1", "Emergency paint layout 1, last 2 color slots for beacons", tableParam, 5, "emg1")

	-- Paint Ends --
	-- Component --

	str = '<vox pos="0.7 1.1 -1.2" rot="0.0 -180.0 0.0" file="MOD/vox/pickup01_ext-parts.vox" object="intake2"/>'
	AddComponent("Air Intake 1", "intake-1", "Black metal air intake", str, {p5 = {"intake"}}, "01")

	tableParam = {
		{'<instance pos="0.0 1.4 1.1" file="MOD/prefab/jeep01-roof_rack01.xml"/>'},
		{'<instance pos="0.0 1.55 -0.32" file="MOD/prefab/light-black_2x2-6.xml"/>', name = "6 Single lights", group = 1},
		{'<instance pos="0.0 1.55 -0.32" file="MOD/prefab/light-black_2x2-7.xml"/>', name = "7 Single lights", group = 1},
		{'<instance pos="0.0 1.55 -0.32" file="MOD/prefab/light-black_14x2.xml"/>', name = "Light bar (14 vox)", group = 1},
		{'<instance pos="0.0 1.55 -0.32" file="MOD/prefab/light-black_16x2.xml"/>', name = "Light bar (16 vox)", group = 1}
	}
	AddComponent("Roof Rack 1", "roofr_1", "Black roof rack with optional lights", tableParam, {p5 = {"roofr", "bcnT"}})

	str = '<instance pos="0.0 1.35 1.05" file="MOD/prefab/jeep01-roof_rack_light01.xml"/>'
	AddComponent("Roof Rack 2", "roofr_2", "Black roof rack with additional lights", str, {p3 = {1}, p5 = {"roofr", "bcnT"}})

	tableParam = {
		{'<instance pos="0.0 -0.35 -2.6" file="MOD/prefab/jeep01-front_bumper01.xml"/>'},
		{'<instance pos="0.0 -0.15 -2.7" file="MOD/prefab/winch01.xml"/>', name = "Winch", group = 1},
		{'<instance pos="0.0 0.45 -2.78" file="MOD/prefab/light-black_8x2.xml"/>', name = "Light bar (8 vox)", group = 2},
		{'<instance pos="0.0 0.51 -2.71" file="MOD/prefab/light-black_2x2-4.xml"/>', name = "4 Single lights", group = 2}
	}
	AddComponent("Front Bumper 1", "fbumper_1", "Black front bumper with optional parts", tableParam, {p5 = {"fbumper"}})

	tableParam = {
		{approx = true},
		{
			'<group pos="0.15 2.15 -0.3" prop0="strength=4">\
			REPLACECOMPbcnPT_2<instance pos="0.0 0.0 0.0" file="MOD/prefab/beacon-base01_6x4-2+3.xml"/>END\
			REPLACECOMPbcnRPa_2<instance pos="-0.4 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type01a.xml"/>END\
			REPLACECOMPbcnRPb_2<instance pos="0.5 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type01b.xml"/>END\
			</group>',
			name = "Light bar, type 1A", group = 1
		},
		{
			'<group pos="0.15 2.15 -0.3" prop0="strength=4">\
			REPLACECOMPbcnPT_2<instance pos="0.0 0.0 0.0" file="MOD/prefab/beacon-base01_6x4-2+3.xml"/>END\
			REPLACECOMPbcnRPa_3<instance pos="-0.4 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type02a.xml"/>END\
			REPLACECOMPbcnRPb_3<instance pos="0.5 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type02b.xml"/>END\
			</group>',
			name = "Light bar, type 1B", group = 1
		},
		{
			'<group pos="0.15 2.15 -0.3" prop0="strength=4">\
			REPLACECOMPbcnPT_2<instance pos="0.0 0.0 0.0" file="MOD/prefab/beacon-base01_6x4-2+3.xml"/>END\
			REPLACECOMPbcnRPa_4<instance pos="-0.4 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type03a.xml"/>END\
			REPLACECOMPbcnRPb_4<instance pos="0.5 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type03b.xml"/>END\
			</group>',
			name = "Light bar, type 1C", group = 1
		},
		{
			'<group pos="0.15 2.15 -0.3" prop0="strength=4">\
			REPLACECOMPbcnPT_2<instance pos="0.0 0.0 0.0" file="MOD/prefab/beacon-base01_6x4-2+3.xml"/>END\
			REPLACECOMPbcnRPa_5<instance pos="-0.4 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type04a.xml"/>END\
			REPLACECOMPbcnRPb_5<instance pos="0.5 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type04b.xml"/>END\
			</group>',
			name = "Light bar, type 1D", group = 1
		},
		{
			'<group pos="0.15 2.15 -0.3" prop0="strength=4">\
			REPLACECOMPbcnPT_2<instance pos="0.0 0.0 0.0" file="MOD/prefab/beacon-base01_6x4-2+3.xml"/>END\
			REPLACECOMPbcnRPa_5<instance pos="-0.4 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type05a.xml"/>END\
			REPLACECOMPbcnRPb_5<instance pos="0.5 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type05b.xml"/>END\
			</group>',
			name = "Light bar, type 1E", group = 1
		}
	}
	AddComponent("Rooftop Beacons", "bcnT_base", "Add a rooftop beacon light bar, default white light", tableParam, {p4 = {-6}, p5 = {"roofr"}}, "bcnT")

	tableParam = {
		{noOption = true},
		{'<instance pos="0.0 0.0 0.0" file="MOD/prefab/beacon-base01b_6x4-2+3.xml"/>'}
	}
	AddComponent("Black beacons", "", "Paint all beacons frame & body to black", tableParam, {p4 = {-6}, p5 = {"=bcnT_base"}}, "bcnPT")

	tableParam = {
		{instance = true, canPaint = true, noOption = true},
		{'<instance pos="-0.4 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type01a.xml"/>'},
		{'<instance pos="-0.4 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type02a.xml"/>'},
		{'<instance pos="-0.4 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type03a.xml"/>'},
		{'<instance pos="-0.4 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type04a.xml"/>'},
		{'<instance pos="-0.4 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type05a.xml"/>'}
	}
	AddComponent("Beacon Color A", "", "Change one color used by beacon", tableParam, {p4 = {-6}, p5 = {"=bcnT_base"}}, "bcnRPa")

	tableParam = {
		{instance = true, canPaint = true, noOption = true},
		{'<instance pos="0.5 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type01b.xml"/>'},
		{'<instance pos="0.5 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type02b.xml"/>'},
		{'<instance pos="0.5 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type03b.xml"/>'},
		{'<instance pos="0.5 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type04b.xml"/>'},
		{'<instance pos="0.5 0.2 0.0" file="MOD/prefab/beacon_6x4-2+3-type05b.xml"/>'}
	}
	AddComponent("Beacon Color B", "", "Change one color used by beacon", tableParam, {p4 = {-6}, p5 = {"=bcnT_base"}}, "bcnRPb")

	tableParam = {
		{noOption = true, canPaint = true},
		{'<voxbox pos="-0.3 0.9 -0.5" size="3 2 2" brush="MOD/vox/pickup01_main.vox" object="mirrorRp"/>'},
		{'<voxbox pos="-0.1 0.9 -0.5" size="3 2 2" brush="MOD/vox/pickup01_main.vox" object="mirrorLp"/>'}
	}
	AddComponent("Painted Mirrors", "nmirr_1", "Replace default black mirrors to painted", tableParam, {p5 = {"nmirr"}}, "02")

	tableParam = {
		{noOption = true},
		{'<vox pos="-0.1 0.9 -0.4" rot="0.0 -180.0 0.0" file="MOD/vox/pickup01_main.vox" object="mirrorLch"/>'},
		{'<vox pos="0.1 0.9 -0.4" rot="0.0 -180.0 0.0" file="MOD/vox/pickup01_main.vox" object="mirrorRch"/>'}
	}
	AddComponent("Chromed Mirrors", "nmirr_2", "Replace default black mirrors to chromed", tableParam, {p5 = {"nmirr"}}, "02")

	tableParam = {
		{canPaint = true},
		{'<voxbox pos="-1.0 1.0 -2.8" size="2 3 2" brush="MOD/vox/pickup01_main.vox" object="admirrorRp"/>', name = "Left"},
		{'<voxbox pos="0.7 1.0 -2.8" size="2 3 2" brush="MOD/vox/pickup01_main.vox" object="admirrorLp"/>', name = "Right"}
	}
	AddComponent("Painted Additional Mirrors", "admirr_1", "Add painted additional mirrors", tableParam, {p5 = {"admirr"}}, "03")

	tableParam = {
		{},
		{'<vox pos="-0.9 1.0 -2.7" rot="0.0 -180.0 0.0" file="MOD/vox/pickup01_main.vox" object="admirrorLch"/>', name = "Left"},
		{'<vox pos="0.8 1.0 -2.7" rot="0.0 -180.0 0.0" file="MOD/vox/pickup01_main.vox" object="admirrorRch"/>', name = "Right"}
	}
	AddComponent("Chromed Additional Mirrors", "admirr_2", "Add chromed additional mirrors", tableParam, {p5 = {"admirr"}}, "03")

	tableParam = {
		{},
		{'<vox pos="-0.9 1.0 -2.7" rot="0.0 -180.0 0.0" file="MOD/vox/pickup01_main.vox" object="admirrorL"/>', name = "Left"},
		{'<vox pos="0.8 1.0 -2.7" rot="0.0 -180.0 0.0" file="MOD/vox/pickup01_main.vox" object="admirrorR"/>', name = "Right"}
	}
	AddComponent("Black Additional Mirrors", "admirr_3", "Add black additional mirrors", tableParam, {p5 = {"admirr"}}, "03")

FinishVehicle()